/*
 * Header file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#ifndef __PROPERTIESWIDGET__
  #define __PROPERTIESWIDGET__

#include "../pguiman.h"

// Properties lists
typedef struct column_select_window{
	GtkWidget *window;
	GtkEntry * entry;
	GtkWidget *awailable_columns;
	GtkWidget *selected_columns;
	gint x;
	gint y;
	gint width;
	gint height;
} T_Col_select_window;

gboolean
focus_in_event (GtkWidget *widget, GdkEventFocus *event, gpointer   user_data);

gboolean
focus_out_event (GtkWidget *widget, GdkEventFocus *event, gpointer   user_data);

gboolean
focus_event (GtkWidget *widget, GdkEventFocus *event, gpointer   user_data);

// Properties view lines                                        
void
add_header_proper(GtkBox * column1, GtkBox * column2, gchar * label, gchar * image);

void
add_noneditable_property(GtkBox * column1, GtkBox * column2, gchar * label, gchar * property);

void
add_entry_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar * text);

void
add_comment_entry_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar * text);

void
add_spin_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gint number, gint min, gint max);

void
add_combo_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar ** list, gint n_list, gint active);

void
add_toggle_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gboolean property, gboolean editable);

void
add_column_property(gchar * widget_name, GtkWidget * page, GtkBox * column1, GtkBox * column2, gchar * label, gchar * text, T_Profile * profile, gint i_schema, gint i_table, T_Column ** columns, gint n_cols);

void
column_select_property_close(GtkButton * button, gpointer user_data);

void
column_select_property_drop_down(GtkButton * button, gpointer user_data);

void
column_select_property_select_all(GtkButton * button, gpointer user_data);

void
column_select_property_select(GtkButton * button, gpointer user_data);

void
column_select_property_remove(GtkButton * button, gpointer user_data);

void
column_select_property_remove_all(GtkButton * button, gpointer user_data);

void
create_column_select_property_list_view     (GtkWidget * view, gchar * title);

// properties callbacks

void
textview_changed (GtkTextBuffer *textbuffer, gpointer user_data);
                    
void
on_entry_text_changed (GtkEditable *editable, gpointer user_data);

void
on_spin_changed (GtkEditable *editable, gpointer user_data);
                                        
void
on_combo_changed (GtkComboBox *combobox, gpointer user_data);
                                        
void
on_toggle_toggled (GtkToggleButton *togglebutton, gpointer user_data);

#endif

// properties_widget.h
