/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */
 
#include "sensitivity.h"

/*
 * Sets basic sensitivity of controls
 */
void
basic_sensitivity(void)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_edit_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_remove_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_connect_to_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_disconnect_from_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_new_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_drop_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_refresh"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_edit_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_remove_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_connect_to_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_disconnect_from_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_refresh"),FALSE);	
} // basic_sensitivity ()

/*
 * Sets sensitivity of controls when selected disconnected profile
 */
void
disconnected_profile_sensitivity(void)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_edit_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_remove_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_connect_to_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_disconnect_from_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_new_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_drop_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_refresh"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_edit_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_remove_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_connect_to_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_disconnect_from_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_refresh"),FALSE);
} // disconnected_profile_sensitivity ()

/*
 * Sets sensitivity of controls when selected connected profile
 */
void
connected_profile_sensitivity(void)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_edit_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_remove_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_connect_to_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_disconnect_from_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_new_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_drop_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_refresh"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_edit_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_remove_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_connect_to_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_disconnect_from_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_refresh"),TRUE);//
} // connected_profile_sensitivity ()

/*
 * Sets normal sensitivity of controls
 */
void
normal_sensitivity(void)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_edit_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_remove_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_connect_to_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_disconnect_from_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_create_new_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_drop_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_refresh"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db_profile"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_edit_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_remove_db_profile"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_connect_to_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_disconnect_from_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_create_db"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_db_profile_man"),TRUE);//
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_refresh"),TRUE);//
} // normal_sensitivity ()

/*
 * Sets sensitivity of controls when no profile is connected
 */
void
no_profile_connected(void)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_sql_editor"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_sql_editor"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"wel_exec_sql"),FALSE);
} // no_profile_connected ()

/*
 * Sets sensitivity of controls when some profile is connected
 */
void
some_profile_connected(void)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"mb_sql_editor"),TRUE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"tb_sql_editor"),TRUE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"wel_exec_sql"),TRUE);
} // some_profile_connected ()
