/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "welpage_callbacks.h"
#include "../GUI_wizards/db_profile_wizard.h"
#include "../GUI_wizards/db_wizard.h"
#include "../tools/db_profile_manager.h"
#include "../tools/sql_editor.h"

/*
 * Connects welcome page callbacks
 */
void
connect_welpage_signals (GladeXML * source)
{
	GtkWidget * widget;
	
	// Close button
	widget = glade_xml_get_widget(source, "button31");
	g_signal_connect ((gpointer) widget, "clicked",
                    G_CALLBACK (on_welpage_close_clicked),
                    glade_xml_get_widget(source, "welcome_page"));
                    
  // Add database profiles
  widget = glade_xml_get_widget(source, "wel_add_db_profile");
	g_signal_connect ((gpointer) widget, "clicked",
                    G_CALLBACK (on_welpage_add_db_profiles_clicked),
                    NULL);
                    
  // Database profile manager
  widget = glade_xml_get_widget(source, "wel_dbp_manager");
	g_signal_connect ((gpointer) widget, "clicked",
                    G_CALLBACK (on_welpage_db_profile_manager_clicked),
                    NULL);
                    
  // Create new database
  widget = glade_xml_get_widget(source, "wel_create_db");
	g_signal_connect ((gpointer) widget, "clicked",
                    G_CALLBACK (on_welpage_create_db_clicked),
                    NULL);
                    
  // Execute SQL
  widget = glade_xml_get_widget(source, "wel_exec_sql");
	g_signal_connect ((gpointer) widget, "clicked",
                    G_CALLBACK (on_welpage_execute_sql_clicked),
                    NULL);
                    
  // Help
  widget = glade_xml_get_widget(source, "wel_help");
	g_signal_connect ((gpointer) widget, "clicked",
                    G_CALLBACK (on_welpage_help_clicked),
                    NULL);
}

void
on_welpage_close_clicked(GtkButton  *button, gpointer user_data)
{
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(glade_xml_get_widget(xml, "mb_show_wel_page")), FALSE);
	gtk_widget_hide(glade_xml_get_widget(xml, "welcome_page"));
}

void
on_welpage_add_db_profiles_clicked(GtkButton  *button, gpointer user_data)
{
	run_c_db_profile_wizard();
}

void
on_welpage_db_profile_manager_clicked(GtkButton  *button, gpointer user_data)
{
	run_db_profile_manager();
}

void
on_welpage_create_db_clicked(GtkButton  *button, gpointer user_data)
{
	run_c_db_wizard();
}

void
on_welpage_execute_sql_clicked(GtkButton  *button, gpointer user_data)
{
	run_sql_editor();
}

void
on_welpage_help_clicked(GtkButton  *button, gpointer user_data)
{
	gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "help_dialog")));	
	gtk_widget_hide(glade_xml_get_widget(xml, "help_dialog"));
}
