/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "function.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"
#include "../GUI/treeview_functions.h"

/*
 * Creates properties panel
 */
void
create_function_info(GtkWidget * main_notebook ,T_Function * function, gchar * path)
{
	GtkWidget *tab_function_main;	
	
	GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;

  GtkWidget *tab_function;
  GtkWidget *tab_function_vapned1;
  GtkWidget *tab_function_vapned2;
  GtkWidget *tab_function_parameters;
  GtkWidget *tab_function_parameters_label_bg;
  GtkWidget *hbox80;
  GtkWidget *tab_function_parameters_label_img;
  GtkWidget *tab_function_parameters_label;
  GtkWidget *scrolledwindow87;
  GtkWidget *tab_function_parameter_list;
  GtkWidget *tab_function_def;
  GtkWidget *tab_function_def_label_bg;
  GtkWidget *hbox81;
  GtkWidget *tab_function_def_label_img;
  GtkWidget *tab_function_def_label;
  GtkWidget *scrolledwindow81;
  GtkWidget *tab_function_def_text;
  GtkWidget *tab_function_properties;
  GtkWidget *tab_function_properties_label_bg;
  GtkWidget *hbox82;
  GtkWidget *tab_function_properties_label_img;
  GtkWidget *tab_function_properties_label;
  GtkWidget *scrolledwindow82;
  GtkWidget *label223;
  GtkWidget *tab_function_depen;
  GtkWidget *scrolledwindow83;
  GtkWidget *tab_function_depen_dep_on;
  GtkWidget *scrolledwindow84;
  GtkWidget *tab_function_depen_ref_by;
  GtkWidget *label225;
  GtkWidget *scrolledwindow85;
  GtkWidget *tab_function_permissions;
  GtkWidget *label226;
  GtkWidget *scrolledwindow86;
  GtkWidget *tab_function_sql_code;
  GtkWidget *label227;
  GtkWidget *tab_function_tab_label;

  GtkTooltips *tooltips;
	tooltips = gtk_tooltips_new ();
  
  tab_function_main = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_function_main);
  // menu
   
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_function_main), menu, FALSE, TRUE, 0);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Function</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * object_name = normal_text_with_color(function->name, "#000000");
  object = gtk_label_new (object_name);
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Schema</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	T_Profile * profile; 
	if(depth >=5 ){
		parent_name = normal_text_with_color(o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name, "#000000");
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
  database = gtk_label_new (parent_name);
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(create_object, FALSE);
	
  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_function.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new function</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(drop_object, FALSE);
	
  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_function.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop function</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);

	// main window
	tab_function = gtk_notebook_new ();
  gtk_widget_show (tab_function);
  gtk_box_pack_start (GTK_BOX (tab_function_main), tab_function, TRUE, TRUE, 0);

  tab_function_vapned1 = gtk_vpaned_new ();
  gtk_widget_show (tab_function_vapned1);
  gtk_container_add (GTK_CONTAINER (tab_function), tab_function_vapned1);
  gtk_paned_set_position (GTK_PANED (tab_function_vapned1), -1);

  tab_function_vapned2 = gtk_vpaned_new ();
  gtk_widget_show (tab_function_vapned2);
  gtk_paned_pack1 (GTK_PANED (tab_function_vapned1), tab_function_vapned2, TRUE, TRUE);
  gtk_paned_set_position (GTK_PANED (tab_function_vapned2), -1);

  tab_function_parameters = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_function_parameters);
  gtk_paned_pack1 (GTK_PANED (tab_function_vapned2), tab_function_parameters, TRUE, TRUE);

  tab_function_parameters_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_function_parameters_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_function_parameters), tab_function_parameters_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_function_parameters_label_bg, -1, 21);

  hbox80 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox80);
  gtk_container_add (GTK_CONTAINER (tab_function_parameters_label_bg), hbox80);

  tab_function_parameters_label_img = create_pixmap (PIXMAP_DIRECTORY "/Parameters.png");

  gtk_widget_show (tab_function_parameters_label_img);
  gtk_box_pack_start (GTK_BOX (hbox80), tab_function_parameters_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_function_parameters_label_img), 0.52, 0.5);

  tab_function_parameters_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Parameters</span>");
  gtk_widget_show (tab_function_parameters_label);
  gtk_box_pack_start (GTK_BOX (hbox80), tab_function_parameters_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_function_parameters_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_function_parameters_label), 0, 0.99);

  scrolledwindow87 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow87);
  gtk_box_pack_start (GTK_BOX (tab_function_parameters), scrolledwindow87, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow87), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow87), GTK_SHADOW_IN);

  tab_function_parameter_list = gtk_tree_view_new ();
  gtk_widget_show (tab_function_parameter_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow87), tab_function_parameter_list);

  tab_function_def = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_function_def);
  gtk_paned_pack2 (GTK_PANED (tab_function_vapned2), tab_function_def, TRUE, TRUE);

  tab_function_def_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_function_def_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_function_def), tab_function_def_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_function_def_label_bg, -1, 21);

  hbox81 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox81);
  gtk_container_add (GTK_CONTAINER (tab_function_def_label_bg), hbox81);

  tab_function_def_label_img = create_pixmap (PIXMAP_DIRECTORY "/SQL_editor.png");
  gtk_widget_show (tab_function_def_label_img);
  gtk_box_pack_start (GTK_BOX (hbox81), tab_function_def_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_function_def_label_img), 0.52, 0.5);

  tab_function_def_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Definition</span>");
  gtk_widget_show (tab_function_def_label);
  gtk_box_pack_start (GTK_BOX (hbox81), tab_function_def_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_function_def_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_function_def_label), 0, 0.99);

  scrolledwindow81 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow81);
  gtk_box_pack_start (GTK_BOX (tab_function_def), scrolledwindow81, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow81), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow81), GTK_SHADOW_IN);

  tab_function_def_text = gtk_text_view_new ();
  gtk_widget_show (tab_function_def_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow81), tab_function_def_text);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_function_def_text), 7);

  tab_function_properties = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_function_properties);
  gtk_paned_pack2 (GTK_PANED (tab_function_vapned1), tab_function_properties, FALSE, TRUE);

  tab_function_properties_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_function_properties_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_function_properties), tab_function_properties_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_function_properties_label_bg, -1, 21);

  hbox82 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox82);
  gtk_container_add (GTK_CONTAINER (tab_function_properties_label_bg), hbox82);

  tab_function_properties_label_img = create_pixmap (PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_function_properties_label_img);
  gtk_box_pack_start (GTK_BOX (hbox82), tab_function_properties_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_function_properties_label_img), 0.52, 0.5);

  tab_function_properties_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_function_properties_label);
  gtk_box_pack_start (GTK_BOX (hbox82), tab_function_properties_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_function_properties_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_function_properties_label), 0, 0.99);

  scrolledwindow82 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow82);
  gtk_box_pack_start (GTK_BOX (tab_function_properties), scrolledwindow82, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow82), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow82), GTK_SHADOW_IN);

  GtkWidget * viewport = gtk_viewport_new (NULL, NULL);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport), GTK_SHADOW_NONE);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (scrolledwindow82), viewport);
	
	GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);

  label223 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label223);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_function), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_function), 0), label223);
  gtk_label_set_use_markup (GTK_LABEL (label223), TRUE);

  tab_function_depen = gtk_hpaned_new ();
  gtk_widget_show (tab_function_depen);
  gtk_container_add (GTK_CONTAINER (tab_function), tab_function_depen);
  gtk_paned_set_position (GTK_PANED (tab_function_depen), -1);

  scrolledwindow83 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow83);
  gtk_paned_pack1 (GTK_PANED (tab_function_depen), scrolledwindow83, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow83), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow83), GTK_SHADOW_IN);

  tab_function_depen_dep_on = gtk_tree_view_new ();
  gtk_widget_show (tab_function_depen_dep_on);
  gtk_container_add (GTK_CONTAINER (scrolledwindow83), tab_function_depen_dep_on);

  scrolledwindow84 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow84);
  gtk_paned_pack2 (GTK_PANED (tab_function_depen), scrolledwindow84, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow84), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow84), GTK_SHADOW_IN);

  tab_function_depen_ref_by = gtk_tree_view_new ();
  gtk_widget_show (tab_function_depen_ref_by);
  gtk_container_add (GTK_CONTAINER (scrolledwindow84), tab_function_depen_ref_by);

  label225 = gtk_label_new ("<span font_desc='Italic 8'>Dependencies</span>");
  gtk_widget_show (label225);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_function), tab_function_depen, label225);
  gtk_label_set_use_markup (GTK_LABEL (label225), TRUE);

  scrolledwindow85 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow85);
  gtk_container_add (GTK_CONTAINER (tab_function), scrolledwindow85);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow85), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow85), GTK_SHADOW_IN);

  tab_function_permissions = gtk_tree_view_new ();
  gtk_widget_show (tab_function_permissions);
  gtk_container_add (GTK_CONTAINER (scrolledwindow85), tab_function_permissions);

  label226 = gtk_label_new ("<span font_desc='Italic 8'>Permissions</span>");
  gtk_widget_show (label226);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_function), scrolledwindow85, label226);
  gtk_label_set_use_markup (GTK_LABEL (label226), TRUE);

  scrolledwindow86 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow86);
  gtk_container_add (GTK_CONTAINER (tab_function), scrolledwindow86);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow86), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow86), GTK_SHADOW_IN);

  tab_function_sql_code = gtk_text_view_new ();
  gtk_widget_show (tab_function_sql_code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow86), tab_function_sql_code);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_function_sql_code), 7);

  label227 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label227);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_function),scrolledwindow86, label227);
  gtk_label_set_use_markup (GTK_LABEL (label227), TRUE);

  GdkColor color;
	// menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);  
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
	gtk_widget_modify_bg (tab_function_parameters_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_function_properties_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_function_def_label_bg, GTK_STATE_NORMAL, &color);	

 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
  
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Function.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(function->name, "#000000");
  tab_function_tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_function_tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_function_tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_function_tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_function_tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Function Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
  
  g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_close_clicked),
                    tab_function_main);
                    
  image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);

	// Fill in properties
	gint height = 1;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name", function->name);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Owner", function->owner);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", function->comment);
	height += 21;
	text = itoa_n(function->OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Function",  PIXMAP_DIRECTORY "/Function.png");
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Parameters", function->parameters);
	height += 21;
	add_toggle_property("", tab_function_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Returns Set", function->return_set, FALSE);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Return Type", function->return_type);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Language", function->language);
	height += 21;
	add_toggle_property("", tab_function_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Strict", function->strict, FALSE);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Execution Privilegies", function->execution_privilegies);
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Stability", function->stability);
	height += 21;
	gtk_widget_set_size_request (scrolledwindow82, -1, height);
	
	// show sub objects
	// schemas
	gint n = function->n_parameters;
	
	GType types[5];
	types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_function_parameter_list), 0);
	types[1] = GDK_TYPE_PIXBUF;
	types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_function_parameter_list), "Name", 1);
	types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_function_parameter_list), "Type", 3);
	types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_function_parameter_list),"Scope", 4);
	GtkTreeModel * model = GTK_TREE_MODEL(gtk_list_store_newv(5, types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(function->parameter[i]->name,"#980F0F");
		gchar * text2 = normal_text(function->parameter[i]->type);
		gchar * text3 = normal_text(function->parameter[i]->scope);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Parameter.png"), 2, text1, 3, text2, 4, text3, -1);
		free(t); free(text); free(text1); free(text2); free(text3);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_function_parameter_list)), model);
	
	//init definition code textview
	init_text_view( tab_function_def_text, FALSE, function->definition);
	
	// show dependencies
	show_dependencies(GTK_TREE_VIEW(tab_function_depen_dep_on), GTK_TREE_VIEW(tab_function_depen_ref_by), &(function->dep_on), &(function->ref_by));
	
	//init sql code textview
	init_text_view( tab_function_sql_code, FALSE, "-- SQL code");
	
	// create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_function_main;
	page->path = path;
	page->object = function;
	page->close_function = on_tab_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, function->name);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}
} // create_function_info ()
