/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */
 
#include "schema.h"
#include "../database/create_db_objects.h"
#include "../database/edit_db_objects.h"
#include "../database/drop_db_objects.h"
#include "../database/get_db_objects.h"
#include "../GUI_wizards/schema_wizard.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"
#include "../GUI/treeview_functions.h"

/*
 * Creates properties panel
 */
void
create_schema_info(GtkWidget * main_notebook, T_Schema * schema, gchar * path)
{
	GtkWidget *tab_schema_main;	
	
	GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;

  GtkWidget *tab_schema;
  GtkWidget *notebook2;
  GtkWidget *vpaned1;
  GtkWidget *vbox13;
  GtkWidget *tab_schema_olabelbg;
  GtkWidget *hbox70;
  GtkWidget *tab_schema_oimg;
  GtkWidget *tab_schema_olabel;
  GtkWidget *notebook3;
  GtkWidget *scrolledwindow14;
  GtkWidget *treeview10;
  GtkWidget *label149;
  GtkWidget *scrolledwindow15;
  GtkWidget *treeview13;
  GtkWidget *label112;
  GtkWidget *scrolledwindow16;
  GtkWidget *treeview14;
  GtkWidget *label113;
  GtkWidget *scrolledwindow17;
  GtkWidget *treeview15;
  GtkWidget *label114;
  GtkWidget *scrolledwindow18;
  GtkWidget *treeview16;
  GtkWidget *label115;
  GtkWidget *scrolledwindow19;
  GtkWidget *treeview17;
  GtkWidget *label116;
  GtkWidget *scrolledwindow20;
  GtkWidget *treeview18;
  GtkWidget *label117;
  GtkWidget *scrolledwindow22;
  GtkWidget *treeview20;
  GtkWidget *label119;
  GtkWidget *vbox15;
  GtkWidget *tab_schema_propertiesbg;
  GtkWidget *hbox71;
  GtkWidget *tab_schema_pimg;
  GtkWidget *tab_schema_properties;
  GtkWidget *scrolledwindow7;
  GtkWidget *label120;
  GtkWidget *hpaned1;
  GtkWidget *scrolledwindow11;
  GtkWidget *treeview7;
  GtkWidget *scrolledwindow12;
  GtkWidget *treeview8;
  GtkWidget *label121;
  GtkWidget *scrolledwindow13;
  GtkWidget *treeview9;
  GtkWidget *label122;
  GtkWidget *scrolledwindow4;
  GtkWidget *textview1;
  GtkWidget *label123;
  GtkTooltips *tooltips;
	tooltips = gtk_tooltips_new ();
  
  tab_schema_main = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_schema_main);
  // menu
   
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_schema_main), menu, FALSE, TRUE, 0);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Schema</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * object_name = normal_text_with_color(schema->name, "#000000");
  object = gtk_label_new (object_name);
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Database</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	T_Profile * profile; 
	if(depth >=5 ){
		parent_name = normal_text_with_color(o_tree.server[intpath[0]]->profile[intpath[2]]->dbname, "#000000");
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
  database = gtk_label_new (parent_name);
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);
	
  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_schema.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new schema</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);
	
  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_schema.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop schema</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);
  
  // main window
  tab_schema = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_schema);
	gtk_box_pack_start (GTK_BOX (tab_schema_main), tab_schema, TRUE, TRUE, 0);
	
  notebook2 = gtk_notebook_new ();
  gtk_widget_show (notebook2);
  gtk_box_pack_start (GTK_BOX (tab_schema), notebook2, TRUE, TRUE, 0);

  vpaned1 = gtk_vpaned_new ();
  gtk_widget_show (vpaned1);
  gtk_container_add (GTK_CONTAINER (notebook2), vpaned1);
  gtk_paned_set_position (GTK_PANED (vpaned1), -1);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox13);
  gtk_paned_pack1 (GTK_PANED (vpaned1), vbox13, TRUE, TRUE);

  tab_schema_olabelbg = gtk_event_box_new ();
  gtk_widget_show (tab_schema_olabelbg);
  gtk_box_pack_start (GTK_BOX (vbox13), tab_schema_olabelbg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_schema_olabelbg, -1, 21);

  hbox70 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox70);
  gtk_container_add (GTK_CONTAINER (tab_schema_olabelbg), hbox70);

  tab_schema_oimg = create_pixmap(PIXMAP_DIRECTORY "/Schemas.png");
  gtk_widget_show (tab_schema_oimg);
  gtk_box_pack_start (GTK_BOX (hbox70), tab_schema_oimg, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_schema_oimg), 0.52, 0.5);

  tab_schema_olabel = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>label</span>");
  gtk_widget_show (tab_schema_olabel);
  gtk_box_pack_start (GTK_BOX (hbox70), tab_schema_olabel, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_schema_olabel), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_schema_olabel), 0, 0.99);

  notebook3 = gtk_notebook_new ();
  gtk_widget_show (notebook3);
  gtk_box_pack_start (GTK_BOX (vbox13), notebook3, TRUE, TRUE, 0);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook3), GTK_POS_BOTTOM);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook3), TRUE);
  
  g_signal_connect ((gpointer) notebook3, "switch-page",
                    G_CALLBACK (on_tab_schema_objects_change_current_page),
                    hbox70);
  
  scrolledwindow14 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow14);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow14);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow14), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow14), GTK_SHADOW_IN);

  treeview10 = gtk_tree_view_new ();
  gtk_widget_show (treeview10);
  gtk_container_add (GTK_CONTAINER (scrolledwindow14), treeview10);

  label149 = gtk_label_new ("<span font_desc='8'>Tables</span>");
  gtk_widget_show (label149);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 0), label149);
  gtk_label_set_use_markup (GTK_LABEL (label149), TRUE);

  scrolledwindow15 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow15);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow15);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow15), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow15), GTK_SHADOW_IN);

  treeview13 = gtk_tree_view_new ();
  gtk_widget_show (treeview13);
  gtk_container_add (GTK_CONTAINER (scrolledwindow15), treeview13);

  label112 = gtk_label_new ("<span font_desc='8'>Views</span>");
  gtk_widget_show (label112);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 1), label112);
  gtk_label_set_use_markup (GTK_LABEL (label112), TRUE);

  scrolledwindow16 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow16);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow16);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow16), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow16), GTK_SHADOW_IN);

  treeview14 = gtk_tree_view_new ();
  gtk_widget_show (treeview14);
  gtk_container_add (GTK_CONTAINER (scrolledwindow16), treeview14);

  label113 = gtk_label_new ("<span font_desc='8'>Functions</span>");
  gtk_widget_show (label113);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 2), label113);
  gtk_label_set_use_markup (GTK_LABEL (label113), TRUE);

  scrolledwindow17 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow17);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow17);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow17), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow17), GTK_SHADOW_IN);

  treeview15 = gtk_tree_view_new ();
  gtk_widget_show (treeview15);
  gtk_container_add (GTK_CONTAINER (scrolledwindow17), treeview15);

  label114 = gtk_label_new ("<span font_desc='8'>Domains</span>");
  gtk_widget_show (label114);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 3), label114);
  gtk_label_set_use_markup (GTK_LABEL (label114), TRUE);

  scrolledwindow18 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow18);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow18);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow18), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow18), GTK_SHADOW_IN);

  treeview16 = gtk_tree_view_new ();
  gtk_widget_show (treeview16);
  gtk_container_add (GTK_CONTAINER (scrolledwindow18), treeview16);

  label115 = gtk_label_new ("<span font_desc='8'>Aggregates</span>");
  gtk_widget_show (label115);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 4), label115);
  gtk_label_set_use_markup (GTK_LABEL (label115), TRUE);

  scrolledwindow19 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow19);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow19);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow19), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow19), GTK_SHADOW_IN);

  treeview17 = gtk_tree_view_new ();
  gtk_widget_show (treeview17);
  gtk_container_add (GTK_CONTAINER (scrolledwindow19), treeview17);

  label116 = gtk_label_new ("<span font_desc='8'>Sequences</span>");
  gtk_widget_show (label116);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 5), label116);
  gtk_label_set_use_markup (GTK_LABEL (label116), TRUE);

  scrolledwindow20 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow20);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow20);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow20), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow20), GTK_SHADOW_IN);

  treeview18 = gtk_tree_view_new ();
  gtk_widget_show (treeview18);
  gtk_container_add (GTK_CONTAINER (scrolledwindow20), treeview18);

  label117 = gtk_label_new ("<span font_desc='8'>Types</span>");
  gtk_widget_show (label117);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 6), label117);
  gtk_label_set_use_markup (GTK_LABEL (label117), TRUE);

  scrolledwindow22 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow22);
  gtk_container_add (GTK_CONTAINER (notebook3), scrolledwindow22);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow22), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow22), GTK_SHADOW_IN);

  treeview20 = gtk_tree_view_new ();
  gtk_widget_show (treeview20);
  gtk_container_add (GTK_CONTAINER (scrolledwindow22), treeview20);

  label119 = gtk_label_new ("<span font_desc='8'>Operators</span>");
  gtk_widget_show (label119);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 7), label119);
  gtk_label_set_use_markup (GTK_LABEL (label119), TRUE);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox15);
  gtk_paned_pack2 (GTK_PANED (vpaned1), vbox15, FALSE, TRUE);

  tab_schema_propertiesbg = gtk_event_box_new ();
  gtk_widget_show (tab_schema_propertiesbg);
  gtk_box_pack_start (GTK_BOX (vbox15), tab_schema_propertiesbg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_schema_propertiesbg, -1, 21);

  hbox71 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox71);
  gtk_container_add (GTK_CONTAINER (tab_schema_propertiesbg), hbox71);

  tab_schema_pimg = create_pixmap(PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_schema_pimg);
  gtk_box_pack_start (GTK_BOX (hbox71), tab_schema_pimg, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_schema_pimg), 0.52, 0.5);

  tab_schema_properties = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_schema_properties);
  gtk_box_pack_start (GTK_BOX (hbox71), tab_schema_properties, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_schema_properties), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_schema_properties), 0, 0.99);

  scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow7);
  gtk_box_pack_start (GTK_BOX (vbox15), scrolledwindow7, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_SHADOW_IN);

  GtkWidget * viewport = gtk_viewport_new (NULL, NULL);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport), GTK_SHADOW_NONE);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (scrolledwindow7), viewport);
	
	GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);


  label120 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label120);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 0), label120);
  gtk_label_set_use_markup (GTK_LABEL (label120), TRUE);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_show (hpaned1);
  gtk_container_add (GTK_CONTAINER (notebook2), hpaned1);
  gtk_paned_set_position (GTK_PANED (hpaned1), -1);

  scrolledwindow11 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow11);
  gtk_paned_pack1 (GTK_PANED (hpaned1), scrolledwindow11, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow11), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow11), GTK_SHADOW_IN);

  treeview7 = gtk_tree_view_new ();
  gtk_widget_show (treeview7);
  gtk_container_add (GTK_CONTAINER (scrolledwindow11), treeview7);

  scrolledwindow12 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow12);
  gtk_paned_pack2 (GTK_PANED (hpaned1), scrolledwindow12, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow12), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow12), GTK_SHADOW_IN);

  treeview8 = gtk_tree_view_new ();
  gtk_widget_show (treeview8);
  gtk_container_add (GTK_CONTAINER (scrolledwindow12), treeview8);

  label121 = gtk_label_new ("<span font_desc='Italic 8'>Dependencies</span>");
  gtk_widget_show (label121);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 1), label121);
  gtk_label_set_use_markup (GTK_LABEL (label121), TRUE);

  scrolledwindow13 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow13);
  gtk_container_add (GTK_CONTAINER (notebook2), scrolledwindow13);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow13), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow13), GTK_SHADOW_IN);

  treeview9 = gtk_tree_view_new ();
  gtk_widget_show (treeview9);
  gtk_container_add (GTK_CONTAINER (scrolledwindow13), treeview9);

  label122 = gtk_label_new ("<span font_desc='Italic 8'>Permissions</span>");
  gtk_widget_show (label122);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 2), label122);
  gtk_label_set_use_markup (GTK_LABEL (label122), TRUE);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow4);
  gtk_container_add (GTK_CONTAINER (notebook2), scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_SHADOW_IN);

  textview1 = gtk_text_view_new ();
  gtk_widget_show (textview1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), textview1);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (textview1), 7);

  label123 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label123);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 3), label123);
  gtk_label_set_use_markup (GTK_LABEL (label123), TRUE);

	GdkColor color;
	// menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);
	
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
	gtk_widget_modify_bg (tab_schema_olabelbg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_schema_propertiesbg, GTK_STATE_NORMAL, &color);


 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_label;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
 
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Schema.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(schema->name, "#000000");
  tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Schema Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
  
  image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);
  
    // connect signals
	g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_schema_close_clicked),
                    tab_schema_main);
                    
  g_signal_connect ((gpointer) create_object, "clicked",
                    G_CALLBACK (on_tab_schema_create_new_object_clicked),
                    tab_schema_main);
                    
	g_signal_connect ((gpointer) drop_object, "clicked",
                    G_CALLBACK (on_tab_schema_drop_object_clicked),
                    tab_schema_main);
                                        
  g_signal_connect ((gpointer) apply_changes, "clicked",
                    G_CALLBACK (on_tab_schema_apply_changes_clicked),
                    tab_schema_main);
                    
	// Show properties	
	gint height = 1;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_entry_property("property_name", tab_schema_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name",  schema->name);
	height += 21;	
	T_Roles * roles = get_roles(profile, FALSE);
	if(roles != NULL){
		gint role_id=-1;
		for(int i = 0; i < roles->n_roles; i++){
			if(strcmp(roles->name[i], schema->owner) == 0){
				role_id = i;
				break;
			}
		}
		add_combo_property("property_owner", tab_schema_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Owner", roles->name,  roles->n_roles, role_id);
		for(int i = 0; i < roles->n_roles; i++){
			free(roles->name[i]);
		}
		free(roles->name);
		free(roles);
	}
	height += 21;	
	add_comment_entry_property("property_comment", tab_schema_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", schema->comment);
	height += 41;
	text = itoa_n(schema->OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	gtk_widget_set_size_request (scrolledwindow7, -1, height);	
	
	// show sub objects
	// tables
	gint n = schema->n_tables;
	
	GType tab_types[7];
	tab_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview10), 0);
	tab_types[1] = GDK_TYPE_PIXBUF;
	tab_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview10), "Name", 1);
	tab_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview10), "Inherites From", 3);
	tab_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview10),"Tablespace", 4);
	tab_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview10),"Owner", 5);
	tab_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview10),"Comment", 6);
	GtkTreeModel * model = GTK_TREE_MODEL(gtk_list_store_newv(7, tab_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->table[i]->name,"#980F0F");
		gchar * text2 = normal_text(schema->table[i]->inherited_from);
		gchar * text3 = normal_text(schema->table[i]->tablespace);
		gchar * text4 = normal_text(schema->table[i]->owner);
		gchar * text5 = normal_text(schema->table[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Table.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview10)), model);

	// views
	n = schema->n_views;
	
	GType view_types[5];
	view_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview13), 0);
	view_types[1] = GDK_TYPE_PIXBUF;
	view_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview13), "Name", 1);
	view_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview13),"Owner", 3);
	view_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview13),"Comment", 4);
	model = GTK_TREE_MODEL(gtk_list_store_newv(5, view_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->view[i]->name,"#980F0F");
		gchar * text2 = normal_text(schema->view[i]->owner);
		gchar * text3 = normal_text(schema->view[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/View.png"), 2, text1, 3, text2, 4, text3, -1);
		free(t); free(text); free(text1); free(text2); free(text3);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview13)), model);
	
	// functions
	n = schema->n_functions;
	
	GType func_types[8];
	func_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview14), 0);
	func_types[1] = GDK_TYPE_PIXBUF;
	func_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview14), "Name", 1);
	func_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview14),"Language", 3);
	func_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview14),"Return Type", 4);
	func_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview14),"Returns Set", 5);
	func_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview14),"Owner", 6);
	func_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview14),"Comment", 7);
	model = GTK_TREE_MODEL(gtk_list_store_newv(8, func_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		
		gchar * nam = append_string(NULL, schema->function[i]->name);
		nam = append_string(nam, "(");
		nam = append_string(nam, schema->function[i]->parameters);
		nam = append_string(nam, ")");
		gchar * text1 = normal_text_with_color(nam,"#980F0F");
		free(nam);
		
		gchar * text2 = normal_text(schema->function[i]->language);
		gchar * text3 = normal_text(schema->function[i]->return_type);
		gchar * text4 = normal_text((schema->function[i]->return_set) ? "True" : "False");
		gchar * text5 = normal_text(schema->function[i]->owner);
		gchar * text6 = normal_text(schema->function[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Function.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview14)), model);
	
	// domains
	n = schema->n_domains;
	
	GType dom_types[7];
	dom_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview15), 0);
	dom_types[1] = GDK_TYPE_PIXBUF;
	dom_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview15), "Name", 1);
	dom_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview15),"Not Null", 3);
	dom_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview15),"Default", 4);
	dom_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview15),"Owner", 5);
	dom_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview15),"Comment", 6);
	model = GTK_TREE_MODEL(gtk_list_store_newv(7, dom_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->domain[i]->name,"#980F0F");
		gchar * text2 = normal_text((schema->domain[i]->not_null) ? "True" : "False");
		gchar * text3 = normal_text(schema->domain[i]->default_value);
		gchar * text4 = normal_text(schema->domain[i]->owner);
		gchar * text5 = normal_text(schema->domain[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Domain.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview15)), model);
	
	// aggregates
	n = schema->n_aggregates;
	
	GType agg_types[11];
	agg_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview16), 0);
	agg_types[1] = GDK_TYPE_PIXBUF;
	agg_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview16), "Name", 1);
	agg_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"Base Type", 3);
	agg_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"State Function", 4);
	agg_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"State Type", 5);
	agg_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"Final Type", 6);
	agg_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"Final Function", 7);
	agg_types[8] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"Initial Condition", 8);
	agg_types[9] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"Owner", 9);
	agg_types[10] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview16),"Comment", 10);
	model = GTK_TREE_MODEL(gtk_list_store_newv(11, agg_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->aggregate[i]->name,"#980F0F");
		gchar * text2 = normal_text(schema->aggregate[i]->base_type);
		gchar * text3 = normal_text(schema->aggregate[i]->state_function);
		gchar * text4 = normal_text(schema->aggregate[i]->state_type);
		gchar * text5 = normal_text(schema->aggregate[i]->final_function);
		gchar * text6 = normal_text(schema->aggregate[i]->final_type);
		gchar * text7 = normal_text(schema->aggregate[i]->initial_condition);
		gchar * text8 = normal_text(schema->aggregate[i]->owner);
		gchar * text9 = normal_text(schema->aggregate[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Aggregate.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, 8, text7, 9, text8, 10, text9, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7); free(text8); free(text9);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview16)), model);
	
	// sequences
	n = schema->n_sequences;
	
	GType seq_types[11];
	seq_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview17), 0);
	seq_types[1] = GDK_TYPE_PIXBUF;
	seq_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview17), "Name", 1);
	seq_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Value", 3);
	seq_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Increment", 4);
	seq_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Min Value", 5);
	seq_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Max Value", 6);
	seq_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Cache", 7);
	seq_types[8] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Cycle", 8);
	seq_types[9] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Owner", 9);
	seq_types[10] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview17),"Comment", 10);
	model = GTK_TREE_MODEL(gtk_list_store_newv(11, seq_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->sequence[i]->name,"#980F0F");
		gchar * text2 = normal_text(schema->sequence[i]->value);
		gchar * text3 = normal_text(schema->sequence[i]->increment);
		gchar * text4 = normal_text(schema->sequence[i]->min_value);
		gchar * text5 = normal_text(schema->sequence[i]->max_value);
		gchar * text6 = normal_text(schema->sequence[i]->cache);
		gchar * text7 = normal_text((schema->sequence[i]->cycle) ? "True" : "False");
		gchar * text8 = normal_text(schema->sequence[i]->owner);
		gchar * text9 = normal_text(schema->sequence[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Sequence.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, 8, text7, 9, text8, 10, text9, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7); free(text8); free(text9);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview17)), model);
	
	// types
	n = schema->n_types;
	
	GType typ_types[11];
	typ_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview18), 0);
	typ_types[1] = GDK_TYPE_PIXBUF;
	typ_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview18), "Name", 1);
	typ_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Internal Length", 3);
	typ_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Default", 4);
	typ_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Element", 5);
	typ_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Alignment", 6);
	typ_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Passed By Value", 7);
	typ_types[8] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Storage", 8);
	typ_types[9] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Owner", 9);
	typ_types[10] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview18),"Comment", 10);
	model = GTK_TREE_MODEL(gtk_list_store_newv(11, typ_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->type[i]->name,"#980F0F");
		gchar * text2 = normal_text(schema->type[i]->internal_length);
		gchar * text3 = normal_text(schema->type[i]->Default);
		gchar * text4 = normal_text(schema->type[i]->element);
		gchar * text5 = normal_text(schema->type[i]->alignment);
		gchar * text6 = normal_text((schema->type[i]->passed_by_value) ? "True" : "False");
		gchar * text7 = normal_text(schema->type[i]->storage);
		gchar * text8 = normal_text(schema->type[i]->owner);
		gchar * text9 = normal_text(schema->type[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Type.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, 8, text7, 9, text8, 10, text9, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7); free(text8); free(text9);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview18)), model);	
	
	// operators
	n = schema->n_operators;
	
	GType op_types[9];
	op_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(treeview20), 0);
	op_types[1] = GDK_TYPE_PIXBUF;
	op_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(treeview20), "Name", 1);
	op_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview20),"Kind", 3);
	op_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview20),"Left Type", 4);
	op_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview20),"Right Type", 5);
	op_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview20),"Function", 6);
	op_types[7] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview20),"Owner", 7);
	op_types[8] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(treeview20),"Comment", 8);
	model = GTK_TREE_MODEL(gtk_list_store_newv(9, op_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(schema->operator[i]->name,"#980F0F");
		gchar * text2 = normal_text(schema->operator[i]->kind);
		gchar * text3 = normal_text(schema->operator[i]->left_operand_type);
		gchar * text4 = normal_text(schema->operator[i]->right_operand_type);
		gchar * text5 = normal_text(schema->operator[i]->function);
		gchar * text6 = normal_text(schema->operator[i]->owner);
		gchar * text7 = normal_text(schema->operator[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Operator.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, 7, text6, 8, text7, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5); free(text6); free(text7);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(treeview20)), model);
	
	// show dependencies
	show_dependencies(GTK_TREE_VIEW(treeview7), GTK_TREE_VIEW(treeview8), &(schema->dep_on), &(schema->ref_by));
	
	gchar * sql = create_new_schema_SQL_query(schema);
	//init sql code textview
	init_text_view(  textview1, FALSE, sql);
	free(sql);
	
	// create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_schema_main;
	page->path = path;
	page->object = schema;
	page->close_function = on_tab_schema_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, schema->name);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook3), 2);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook3), 0);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}
}//create_schema_info

/*
 * Subobject notebook page changed
 */
void
on_tab_schema_objects_change_current_page (GtkNotebook *notebook, GtkNotebookPage *page, guint page_num, gpointer user_data)
{
	GList * children = gtk_container_get_children(GTK_CONTAINER(user_data));
	GtkWidget * label = NULL;
	GtkWidget * image = NULL;
	do{
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_LABEL) label = children->data;
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_IMAGE) image = children->data;
		children = children->next;
 	}while(children != NULL);
	
	switch(page_num){
	  case 0: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Tables.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Tables</span>");
									break;
		case 1: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Views.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Views</span>");
									break;
		case 2: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Functions.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Functions</span>");
									break;
		case 3: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Domains.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Domains</span>");
									break;
		case 4: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Aggregates.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Aggregates</span>");
									break;
		case 5: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Sequences.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Sequences</span>");
									break;
		case 6: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Types.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Types</span>");
									break;									
    case 7: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Operators.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Operators</span>");
									break;									
		}
} // on_tab_schema_objects_change_current_page ()

/*
 * Close properties panel
 */
gboolean
on_tab_schema_close_clicked(GtkButton  *button, gpointer         user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		gtk_widget_destroy(GTK_WIDGET(user_data));
	}
	else{ // widget found
		if(page->modified){
			gchar * object_type = normal_text_with_color("Schema", "#000000");
			
			GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
			gint depth = gtk_tree_path_get_depth(path);
			gint * intpath = gtk_tree_path_get_indices(path);
			gchar * object_name;
			if(depth >=3 ){
			  object_name = bold_text(o_tree.server[intpath[0]]->profile[intpath[2]]->alias, "#980F0F");
			}
			else{
				object_name = bold_text(" ", "#980F0F");
			}
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_type")), object_type);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_name")), object_name);
			free(object_type);
			free(object_name);
	
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "question_dialog")));
			if(res == GTK_RESPONSE_YES){ // Yes
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				
				on_tab_schema_apply_changes_clicked(NULL, user_data);
				
				remove_page_from_list( &notebook, page);
			}
			else if(res == GTK_RESPONSE_NO){ // No
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				remove_page_from_list( &notebook, page);
			}
			else{ // Cancel
			  gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
			  return FALSE;
			}
		}
		else remove_page_from_list( &notebook, page);
	}
	
	
	return TRUE;
} // on_tab_schema_close_clicked  ()

/*
 * Apply changes
 */
void
on_tab_schema_apply_changes_clicked(GtkButton *button, gpointer user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// new profile struct 
		T_Schema * new_schema, *old_schema;
		new_schema = (T_Schema *) malloc (sizeof(T_Schema));
		if(new_schema == NULL){
		   	fprintf(stderr, "Memory allocation error.");
	 			exit(0);
		}
		
		old_schema = (T_Schema *) page->object;
		
		// get properties
		GtkWidget * wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_name");
		if(wid == NULL) return;
		new_schema->name = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
		
		wid = NULL;
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_owner");
		if(wid == NULL) return;
		new_schema->owner = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
		
		wid = get_widget_child_by_name(GTK_WIDGET(user_data), "property_comment");
		if(wid == NULL) return;
		GtkTextBuffer * buffer;
		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
		GtkTextIter start, end;
  	gtk_text_buffer_get_start_iter(buffer, &start);
  	gtk_text_buffer_get_end_iter(buffer, &end);
		
		new_schema->comment = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
		
		// get server and profile
		GtkTreePath * path = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(path);
		gint * intpath = gtk_tree_path_get_indices(path);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
		  profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else	return;
		
		gchar * sql = create_edit_schema_SQL_query(old_schema, new_schema);
		if(sql != NULL){
			if(!execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
				free(sql);
				return;
			}
			page->modified = FALSE;
			gui_refresh(server, profile);
			free(sql);
		}
		else{
			page->modified = FALSE;
			gui_refresh(server, profile);
		}
		
		free(new_schema->name);
		free(new_schema->owner);
		free(new_schema->comment);
		free(new_schema);
	
	}
} // on_tab_schema_apply_changes_clicked ()

/*
 * Create new object
 */
void
on_tab_schema_create_new_object_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		run_c_schema_wizard(profile);
	}
} // on_tab_schema_create_new_object_clicked ()

/*
 * Drop object
 */
void
on_tab_schema_drop_object_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth == 5){		
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
			// run dialog to confirm delete
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")), FALSE);
			gchar * label = append_string(NULL, "Do you really want to drop schema '");
			label = append_string(label, profile->database.schema[intpath[4]]->name);	
			label = append_string(label, "'?");
			gchar * l = normal_text(label);
			free(label);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml,"drop_dialog_label")), l);
			free(l);
			gboolean cascade = FALSE;
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "drop_dialog")));
			if(res == GTK_RESPONSE_YES){
				cascade = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")));
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));
			}
			else{
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));	
				return;
			}
		
			// create sql code
			gchar * sql = create_drop_schema_SQL_query(profile->database.schema[intpath[4]], cascade);
			
			// execute sql
			if(sql != NULL){
				if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
					free(sql);
				  gui_refresh(server, profile);
				}
				else free(sql);
			}
		}
	}
} // on_tab_schema_drop_object_clicked ()
