/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "trigger.h"
#include "../database/create_db_objects.h"
#include "../database/edit_db_objects.h"
#include "../database/drop_db_objects.h"
#include "../GUI_wizards/trigger_wizard.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"

/*
 * Creates properties panel
 */
void
create_trigger_info(GtkWidget * main_notebook ,T_Trigger * trigger, gchar * path)
{
	GtkWidget *tab_trigger_main;	
	
	GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;
  
  GtkWidget *tab_trigger;
  GtkWidget *tab_trigger_properties;
  GtkWidget *tab_trigger_properties_label_bg;
  GtkWidget *hbox88;
  GtkWidget *tab_trigger_properties_label_img;
  GtkWidget *tab_trigger_properties_label;
  GtkWidget *scrolledwindow123;
  GtkWidget *label268;
  GtkWidget *tab_trigger_depen_hpend;
  GtkWidget *scrolledwindow119;
  GtkWidget *tab_trigger_depen_dep_on;
  GtkWidget *scrolledwindow120;
  GtkWidget *tab_trigger_depen_ref_by;
  GtkWidget *label269;
  GtkWidget *scrolledwindow122;
  GtkWidget *tab_trigger_sql_code;
  GtkWidget *label271;
  GtkWidget *tab_trigger_tab_label;
  
  GtkTooltips *tooltips;
	tooltips = gtk_tooltips_new ();
  
  tab_trigger_main = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_trigger_main);
  // menu
   
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_trigger_main), menu, FALSE, TRUE, 0);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Trigger</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * obj = append_string(NULL, trigger->table_name);
	obj = append_string(obj, ".");
	obj = append_string(obj, trigger->name);
	gchar * object_name = normal_text_with_color(obj, "#000000");
	free(obj);
  object = gtk_label_new (object_name);
  gtk_widget_set_name(object, "property_parent");
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Schema</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	T_Profile * profile; 
	if(depth >=5 ){
		parent_name = normal_text_with_color(o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name, "#000000");
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
  database = gtk_label_new (parent_name);
  gtk_widget_set_name(database, "property_schema");
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);
	
  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_trigger.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new trigger</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);
	
  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_trigger.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop trigger</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);
  
  // main window
  tab_trigger = gtk_notebook_new ();
  gtk_widget_show (tab_trigger);
  gtk_box_pack_start (GTK_BOX (tab_trigger_main), tab_trigger, TRUE, TRUE, 0);

  tab_trigger_properties = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_trigger_properties);
  gtk_container_add (GTK_CONTAINER (tab_trigger), tab_trigger_properties);

  tab_trigger_properties_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_trigger_properties_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_trigger_properties), tab_trigger_properties_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_trigger_properties_label_bg, -1, 21);

  hbox88 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox88);
  gtk_container_add (GTK_CONTAINER (tab_trigger_properties_label_bg), hbox88);

  tab_trigger_properties_label_img = create_pixmap (PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_trigger_properties_label_img);
  gtk_box_pack_start (GTK_BOX (hbox88), tab_trigger_properties_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_trigger_properties_label_img), 0.52, 0.5);

  tab_trigger_properties_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_trigger_properties_label);
  gtk_box_pack_start (GTK_BOX (hbox88), tab_trigger_properties_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_trigger_properties_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_trigger_properties_label), 0, 0.99);

  scrolledwindow123 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow123);
  gtk_box_pack_start (GTK_BOX (tab_trigger_properties), scrolledwindow123, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow123), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow123), GTK_SHADOW_IN);

  GtkWidget * viewport = gtk_viewport_new (NULL, NULL);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport), GTK_SHADOW_NONE);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (scrolledwindow123), viewport);
	
	GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);

  label268 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label268);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_trigger), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_trigger), 0), label268);
  gtk_label_set_use_markup (GTK_LABEL (label268), TRUE);

  tab_trigger_depen_hpend = gtk_hpaned_new ();
  gtk_widget_show (tab_trigger_depen_hpend);
  gtk_container_add (GTK_CONTAINER (tab_trigger), tab_trigger_depen_hpend);
  gtk_paned_set_position (GTK_PANED (tab_trigger_depen_hpend), -1);

  scrolledwindow119 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow119);
  gtk_paned_pack1 (GTK_PANED (tab_trigger_depen_hpend), scrolledwindow119, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow119), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow119), GTK_SHADOW_IN);

  tab_trigger_depen_dep_on = gtk_tree_view_new ();
  gtk_widget_show (tab_trigger_depen_dep_on);
  gtk_container_add (GTK_CONTAINER (scrolledwindow119), tab_trigger_depen_dep_on);

  scrolledwindow120 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow120);
  gtk_paned_pack2 (GTK_PANED (tab_trigger_depen_hpend), scrolledwindow120, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow120), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow120), GTK_SHADOW_IN);

  tab_trigger_depen_ref_by = gtk_tree_view_new ();
  gtk_widget_show (tab_trigger_depen_ref_by);
  gtk_container_add (GTK_CONTAINER (scrolledwindow120), tab_trigger_depen_ref_by);

  label269 = gtk_label_new ("<span font_desc='Italic 8'>Dependencies</span>");
  gtk_widget_show (label269);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_trigger), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_trigger), 1), label269);
  gtk_label_set_use_markup (GTK_LABEL (label269), TRUE);

  scrolledwindow122 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow122);
  gtk_container_add (GTK_CONTAINER (tab_trigger), scrolledwindow122);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow122), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow122), GTK_SHADOW_IN);

  tab_trigger_sql_code = gtk_text_view_new ();
  gtk_widget_show (tab_trigger_sql_code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow122), tab_trigger_sql_code);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_trigger_sql_code), 7);

  label271 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label271);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_trigger), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_trigger), 2), label271);
  gtk_label_set_use_markup (GTK_LABEL (label271), TRUE);

  GdkColor color;
  // menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);  
   
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
	gtk_widget_modify_bg (tab_trigger_properties_label_bg, GTK_STATE_NORMAL, &color);

 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
  
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Trigger.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(trigger->name, "#000000");
  tab_trigger_tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_trigger_tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_trigger_tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_trigger_tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_trigger_tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Trigger Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
 
  image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);
	
	// connect signals
	g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_trigger_close_clicked),
                    tab_trigger_main);
                    
  g_signal_connect ((gpointer) create_object, "clicked",
                    G_CALLBACK (on_tab_trigger_create_new_object_clicked),
                    tab_trigger_main);
                    
	g_signal_connect ((gpointer) drop_object, "clicked",
                    G_CALLBACK (on_tab_trigger_drop_object_clicked),
                    tab_trigger_main);
                                        
  g_signal_connect ((gpointer) apply_changes, "clicked",
                    G_CALLBACK (on_tab_trigger_apply_changes_clicked),
                    tab_trigger_main);
                    
	// Fill in properties
	gint height = 1;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_entry_property("property_name", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name", trigger->name);
	height += 21;
	add_comment_entry_property("property_comment", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", trigger->comment);
	height += 41;
	text = itoa_n(trigger->OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Trigger",  PIXMAP_DIRECTORY "/Trigger.png");
	height += 21;
	add_toggle_property("property_enabled", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Enabled", trigger->enabled, TRUE);
	height += 21;
	gchar *type[] = {"Before", "After"};
	gint id = -1;
	for(int i = 0; i < 2; i++){
		if(strcmp(type[i], trigger->type) == 0) id = i;
	}
	add_combo_property("property_type", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Type", type,  2, id);
	height += 21;
	gchar *for_each[] = {"Row", "Statement"};
	id = -1;
	for(int i = 0; i < 2; i++){
		if(strcmp(for_each[i], trigger->for_each) == 0) id = i;
	}
	add_combo_property("property_for_each", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "For Each", for_each,  2, id);
	height += 21;
	add_entry_property("property_events", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Event(s)", trigger->events);
	height += 21;
	
	// make list of available functions
	gchar ** list = NULL;
	gint n = 0;
	for(int i = 0; i < profile->database.n_schemas; i++){
		for(int j = 0; j < profile->database.schema[i]->n_functions; j++){
			T_Function * function = profile->database.schema[i]->function[j];
			if(strcmp(function->return_type, "trigger") == 0){
				 gchar * func = append_string(NULL, profile->database.schema[i]->name);
				 func = append_string(func, ".");
				 func = append_string(func, function->name);
				 list = append_string_to_array(list, &n ,func);
			}
		}
	}
	id = -1;
	for(int i = 0; i < n; i++){
		if(strcmp(list[i], trigger->function)  == 0) id = i;
	}
	add_combo_property("property_function", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Function", list,  n, id);
	height += 21;
	for(int i = 0; i < n; i++){
		free(list[i]);
	}
	free(list);
	add_entry_property("property_arguments", tab_trigger_main, GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Arguments", trigger->arguments);
	height += 21;
	
	gtk_widget_set_size_request (scrolledwindow123, -1, height);
	
	// show dependencies
	show_dependencies(GTK_TREE_VIEW(tab_trigger_depen_dep_on), GTK_TREE_VIEW(tab_trigger_depen_ref_by), &(trigger->dep_on), &(trigger->ref_by));
	
	//init sql code textview
	gchar * parent = NULL;
	parent = append_string(parent, o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name);
	parent = append_string(parent, "\".\"");
	parent = append_string(parent, trigger->table_name);
	
	gchar * sql = create_new_trigger_SQL_query(trigger, parent, TRUE, TRUE);
	init_text_view( tab_trigger_sql_code, FALSE, sql);
	free(sql);	
	free(parent);
	
	// create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_trigger_main;
	page->path = path;
	page->object = trigger;
	page->close_function = on_tab_trigger_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, trigger->name);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}
} // create_trigger_info ()

/*
 * Close properties panel
 */
gboolean
on_tab_trigger_close_clicked(GtkButton  *button, gpointer         user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		gtk_widget_destroy(GTK_WIDGET(user_data));
	}
	else{ // widget found
		if(page->modified){
			gchar * object_type = normal_text_with_color("Trigger", "#000000");
			
			gchar * object_name;
			gchar * o_name = NULL;
			o_name = append_string(o_name, ((T_Trigger *) page->object)->table_name);
			o_name = append_string(o_name, ".");
			o_name = append_string(o_name, ((T_Trigger *) page->object)->name);
			
			object_name = bold_text(o_name, "#980F0F");
			free(o_name);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_type")), object_type);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml, "question_dialog_object_name")), object_name);
			free(object_type);
			free(object_name);
	
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "question_dialog")));
			if(res == GTK_RESPONSE_YES){ // Yes
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				
				on_tab_trigger_apply_changes_clicked(NULL, user_data);
				
				remove_page_from_list( &notebook, page);
			}
			else if(res == GTK_RESPONSE_NO){ // No
				gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
				remove_page_from_list( &notebook, page);
			}
			else{ // Cancel
			  gtk_widget_hide(glade_xml_get_widget(xml, "question_dialog"));
			  return FALSE;
			}
		}
		else remove_page_from_list( &notebook, page);
	}
	
	
	return TRUE;
} // on_tab_trigger_close_clicked ()

/*
 * Apply changes
 */
void
on_tab_trigger_apply_changes_clicked(GtkButton *button, gpointer user_data){
	// find if page modified
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{	
		// new profile struct 
		T_Trigger * new_trigger, *old_trigger;
		new_trigger = (T_Trigger *) malloc (sizeof(T_Trigger));
		if(new_trigger == NULL){
		   	fprintf(stderr, "Memory allocation error.");
	 			exit(0);
		}
		
		old_trigger = (T_Trigger *) page->object;
		
	// get properties
	GtkWidget * dialog = GTK_WIDGET(user_data);
		
	// name	
	GtkWidget * wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_name");
	if(wid != NULL){
		new_trigger->name = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
	}
	else new_trigger->name = copy_string("");
	 
	// comment
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_comment");
	if(wid != NULL){
		GtkTextBuffer * buffer;
		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wid));
		GtkTextIter start, end;
  	gtk_text_buffer_get_start_iter(buffer, &start);
  	gtk_text_buffer_get_end_iter(buffer, &end);
		new_trigger->comment = copy_string(gtk_text_buffer_get_text(buffer, &start, &end, TRUE));
	}
	else new_trigger->comment = copy_string("");
	
	// enabled
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_enabled");
	if(wid != NULL){
		new_trigger->enabled = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
	}
	else new_trigger->enabled = FALSE;
	
	// type
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_type");
	if(wid != NULL){
		new_trigger->type = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
	}
	else new_trigger->type = copy_string("");
	
	// for each
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_for_each");
	if(wid != NULL){
		new_trigger->for_each = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
	}
	else new_trigger->for_each = copy_string("");
	
	// events
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_events");
	if(wid != NULL){
		new_trigger->events = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
	}
	else new_trigger->events = copy_string("");
	
	// function
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_function");
	if(wid != NULL){
		new_trigger->function = copy_string(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(wid)->child)));
	}
	else new_trigger->function = copy_string("");
	
	// arguments
	wid = NULL;
	wid = get_widget_child_by_name(dialog, "property_arguments");
	if(wid != NULL){
		new_trigger->arguments = copy_string(gtk_entry_get_text(GTK_ENTRY(wid)));
	}
	else new_trigger->arguments = copy_string("");
	
	// parent_name
		gchar * parent_name = NULL;
	
		wid = NULL;
		wid = get_widget_child_by_name(dialog, "property_schema");
		if(wid != NULL){
			gchar * markup = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
			parent_name = append_string(parent_name, markup);
			free(markup);
		}
		else parent_name = copy_string("");
		wid = get_widget_child_by_name(dialog, "property_parent");
		if(wid != NULL){
			gchar * m = copy_string(gtk_label_get_text(GTK_LABEL(wid)));
			gint k = 0;
			while(m[k] != '.') k++;
			m[k] = '\0';
			parent_name = append_string(parent_name, "\".\"");
			parent_name = append_string(parent_name, m);
			m[k] = '.';
			free(m);
		}
		else parent_name = append_string(parent_name, "");
				
	// get profile		
	GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	T_Profile * profile = NULL;
	if(depth >=3 ){
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
		
		
		gchar * sql = create_edit_trigger_SQL_query(old_trigger, new_trigger, parent_name);
		gboolean cancel = FALSE;
		if(sql != NULL){
			cancel = !execute_sql(sql, NULL, NULL, profile, TRUE, TRUE);
			if(!cancel){
			 page->modified = FALSE;
			 gui_refresh(o_tree.server[intpath[0]], profile);
			}
			free(sql);
		}
		else{
			page->modified = FALSE;
			gui_refresh(o_tree.server[intpath[0]], profile);
		}
		
		free(parent_name);
		free(new_trigger->name);
		free(new_trigger->comment);
		free(new_trigger->type);
		free(new_trigger->for_each);
		free(new_trigger->events);
		free(new_trigger->function);
		free(new_trigger->arguments);
		free(new_trigger);
		
		if(cancel) return;
		
	}
} // on_tab_trigger_apply_changes_clicked ()

/*
 * Create new object
 */
void
on_tab_trigger_create_new_object_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth >=3 ){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		}
		else{
			return;
		}
		run_c_trigger_wizard(profile);
	}
} // on_tab_trigger_create_new_object_clicked ()

/*
 * Drop object
 */
void
on_tab_trigger_drop_object_clicked(GtkButton *button, gpointer user_data){
	T_Page * page;
	if( (page = find_widget_in_page_list(&notebook, GTK_WIDGET(user_data))) == NULL){ // widget not found
		return;
	}
	else{
		// get profile	and server
		GtkTreePath * p = gtk_tree_path_new_from_string(page->path);
		gint depth = gtk_tree_path_get_depth(p);
		gint * intpath = gtk_tree_path_get_indices(p);
		T_Server * server = NULL;
		T_Profile * profile = NULL;
		if(depth == 7 || depth == 9){
			server = o_tree.server[intpath[0]];
			profile = o_tree.server[intpath[0]]->profile[intpath[2]];
		
			// get object name and database profile
			gchar * parent_name = NULL;
			if(depth == 7){
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->name);
				parent_name = append_string(parent_name, "\".\"");
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->trigger[intpath[6]]->table_name);
			}
			else{
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->name);
				parent_name = append_string(parent_name, "\".\"");
				parent_name = append_string(parent_name, profile->database.schema[intpath[4]]->table[intpath[6]]->name);
			}
				
			// run dialog to confirm delete
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")), FALSE);
			gchar * label = append_string(NULL, "Do you really want to drop rule '");
			if(depth == 7){
				label = append_string(label, profile->database.schema[intpath[4]]->trigger[intpath[6]]->table_name);
				label = append_string(label, ".");		
				label = append_string(label, profile->database.schema[intpath[4]]->trigger[intpath[6]]->name);	
			}
			else{
				label = append_string(label, profile->database.schema[intpath[4]]->table[intpath[6]]->name);
				label = append_string(label, ".");		
				label = append_string(label, profile->database.schema[intpath[4]]->table[intpath[6]]->trigger[intpath[8]]->name);	
			}
			label = append_string(label, "'?");
			gchar * l = normal_text(label);
			free(label);
			gtk_label_set_markup(GTK_LABEL(glade_xml_get_widget(xml,"drop_dialog_label")), l);
			free(l);
			gint res = gtk_dialog_run(GTK_DIALOG(glade_xml_get_widget(xml, "drop_dialog")));
			gboolean cascade = FALSE;
			if(res == GTK_RESPONSE_YES){
				cascade = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "drop_dialog_cascade")));
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));
			}
			else{
				gtk_widget_hide(glade_xml_get_widget(xml, "drop_dialog"));	
				return;
			}
		
			// create sql code
			gchar * sql = create_drop_trigger_SQL_query((depth == 7) ? profile->database.schema[intpath[4]]->trigger[intpath[6]] : profile->database.schema[intpath[4]]->table[intpath[6]]->trigger[intpath[8]], parent_name, cascade);
			free(parent_name);
		
		
			// execute sql
			if(sql != NULL){
				if(execute_sql(sql, NULL, NULL, profile, TRUE, TRUE)){
				  free(sql);
				  gui_refresh(server, profile);
				}
				else free(sql);
			}
		}
	}
} // on_tab_trigger_drop_object_clicked ()
