/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "view.h"
#include "../database/create_db_objects.h"
#include "../database/get_db_objects.h"
#include "../GUI/GUI_functions.h"
#include "../GUI/properties_widget.h"
#include "../GUI/textview_functions.h"
#include "../GUI/main_window.h"
#include "../GUI/treeview_functions.h"

/*
 * Creates properties panel
 */
void
create_view_info(GtkWidget * main_notebook ,T_View * view, gchar * path)
{
	GtkWidget *tab_view_main;	
	
	GtkWidget *menu;
  GtkWidget *menu_bg;
  GtkWidget *vbox24;
  GtkWidget *object_bg;
  GtkWidget *vbox25;
  GtkWidget *object_label_bg;
  GtkWidget *object_label;
  GtkWidget *object;
  GtkWidget *database_bg;
  GtkWidget *vbox26;
  GtkWidget *database_label_bg;
  GtkWidget *database_label;
  GtkWidget *database;
  GtkWidget *general_bg;
  GtkWidget *vbox27;
  GtkWidget *general_label_bg;
  GtkWidget *general_label;
  GtkWidget *vbox28;
  GtkWidget *create_object;
  GtkWidget *alignment54;
  GtkWidget *hbox93;
  GtkWidget *image260;
  GtkWidget *label297;
  GtkWidget *drop_object;
  GtkWidget *alignment55;
  GtkWidget *hbox94;
  GtkWidget *image261;
  GtkWidget *label298;
  GtkWidget *apply_changes;
  GtkWidget *alignment56;
  GtkWidget *hbox95;
  GtkWidget *image262;
  GtkWidget *label299;
  GtkWidget *menu_bottom_bg;
  GtkWidget *menu_image;
	
	GtkWidget *tab_view;
  GtkWidget *tab_view_vapend1;
  GtkWidget *tab_view_vapend2;
  GtkWidget *tab_view_objects;
  GtkWidget *tab_view_o_label_bg;
  GtkWidget *hbox78;
  GtkWidget *tab_view_o_label_img;
  GtkWidget *tab_view_o_label;
  GtkWidget *tab_view_object_notebook;
  GtkWidget *scrolledwindow75;
  GtkWidget *tab_view_fields;
  GtkWidget *tab_view_fields_label;
  GtkWidget *scrolledwindow76;
  GtkWidget *tab_view_rules;
  GtkWidget *tab_view_rules_label;
  GtkWidget *tab_view_body;
  GtkWidget *tab_view_body_label_bg;
  GtkWidget *hbox79;
  GtkWidget *tab_view_body_label_img;
  GtkWidget *tab_view_body_label;
  GtkWidget *scrolledwindow78;
  GtkWidget *tab_view_body_text;
  GtkWidget *tab_view_properties;
  GtkWidget *tab_view_properties_label_bg;
  GtkWidget *hbox74;
  GtkWidget *tab_view_properties_label_img;
  GtkWidget *tab_view_properties_label;
  GtkWidget *scrolledwindow46;
  GtkWidget *viewport1;
  GtkWidget *label208;
  GtkWidget *data_tab;
  GtkWidget *hbox96;
  GtkWidget *eventbox3;
  GtkWidget *insert_data;
  GtkWidget *alignment57;
  GtkWidget *hbox97;
  GtkWidget *image263;
  GtkWidget *delete_data;
  GtkWidget *alignment58;
  GtkWidget *hbox98;
  GtkWidget *image264;
  GtkWidget *edit_data;
  GtkWidget *alignment59;
  GtkWidget *hbox99;
  GtkWidget *image265;
  GtkWidget *eventbox4;
  GtkWidget *first;
  GtkWidget *alignment60;
  GtkWidget *hbox100;
  GtkWidget *image266;
  GtkWidget *previous;
  GtkWidget *alignment61;
  GtkWidget *hbox101;
  GtkWidget *image267;
  GtkObject *limit_count_adj;
  GtkWidget *limit_count;
  GtkWidget *next;
  GtkWidget *alignment62;
  GtkWidget *hbox102;
  GtkWidget *image268;
  GtkWidget *last;
  GtkWidget *alignment63;
  GtkWidget *hbox103;
  GtkWidget *image269;
  GtkWidget *eventbox5;
  GtkWidget *fetch_all;
  GtkWidget *alignment64;
  GtkWidget *hbox104;
  GtkWidget *image270;
  GtkWidget *fetch_filtered;
  GtkWidget *alignment65;
  GtkWidget *hbox105;
  GtkWidget *image271;
  GtkWidget *eventbox6;
  GtkWidget *scrolledwindow136;
  GtkWidget *data_view;
  GtkWidget *label209;
  GtkWidget *tab_view_depen_hpend;
  GtkWidget *scrolledwindow71;
  GtkWidget *tab_view_depen_dep_on;
  GtkWidget *scrolledwindow72;
  GtkWidget *tab_view_depen_ref_by;
  GtkWidget *label210;
  GtkWidget *scrolledwindow73;
  GtkWidget *tab_view_permissions;
  GtkWidget *label211;
  GtkWidget *scrolledwindow74;
  GtkWidget *tab_view_sql_code;
  GtkWidget *label212;
  
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();
  
  tab_view_main = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (tab_view_main);
  // menu
   
  menu = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (menu);
  gtk_box_pack_start (GTK_BOX (tab_view_main), menu, FALSE, TRUE, 0);
  gtk_widget_set_size_request (menu, 200, -1);

  menu_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bg, TRUE, TRUE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (menu_bg), vbox24);

  object_bg = gtk_event_box_new ();
  gtk_widget_show (object_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), object_bg, FALSE, TRUE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_container_add (GTK_CONTAINER (object_bg), vbox25);

  object_label_bg = gtk_event_box_new ();
  gtk_widget_show (object_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox25), object_label_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (object_bg), 5);

  object_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   View</span>");
  gtk_widget_show (object_label);
  gtk_container_add (GTK_CONTAINER (object_label_bg), object_label);
  gtk_widget_set_size_request (object_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (object_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (object_label), 0, 0.8);
	
	gchar * object_name = normal_text_with_color(view->name, "#000000");
  object = gtk_label_new (object_name);
  free(object_name);
  gtk_widget_show (object);
  gtk_box_pack_start (GTK_BOX (vbox25), object, FALSE, TRUE, 0);
  gtk_widget_set_size_request (object, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (object), TRUE);

  database_bg = gtk_event_box_new ();
  gtk_widget_show (database_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), database_bg, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (database_bg), 5);
	
  vbox26 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox26);
  gtk_container_add (GTK_CONTAINER (database_bg), vbox26);

  database_label_bg = gtk_event_box_new ();
  gtk_widget_show (database_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox26), database_label_bg, FALSE, TRUE, 0);

  database_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   Schema</span>");
  gtk_widget_show (database_label);
  gtk_container_add (GTK_CONTAINER (database_label_bg), database_label);
  gtk_widget_set_size_request (database_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (database_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (database_label), 0, 0.8);
	
	GtkTreePath * p = gtk_tree_path_new_from_string(path);
	gint depth = gtk_tree_path_get_depth(p);
	gint * intpath = gtk_tree_path_get_indices(p);
	gchar * parent_name;
	T_Profile * profile; 
	if(depth >=5 ){
		parent_name = normal_text_with_color(o_tree.server[intpath[0]]->profile[intpath[2]]->database.schema[intpath[4]]->name, "#000000");
		profile = o_tree.server[intpath[0]]->profile[intpath[2]];
	}
	else{
		return;
	}
  database = gtk_label_new (parent_name);
  free(parent_name);
  
  gtk_widget_show (database);
  gtk_box_pack_start (GTK_BOX (vbox26), database, FALSE, TRUE, 0);
  gtk_widget_set_size_request (database, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (database), TRUE);

  general_bg = gtk_event_box_new ();
  gtk_widget_show (general_bg);
  gtk_box_pack_start (GTK_BOX (vbox24), general_bg, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (general_bg), 5);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_container_add (GTK_CONTAINER (general_bg), vbox27);

  general_label_bg = gtk_event_box_new ();
  gtk_widget_show (general_label_bg);
  gtk_box_pack_start (GTK_BOX (vbox27), general_label_bg, FALSE, TRUE, 0);

  general_label = gtk_label_new ("<span font_desc='Tahoma Bold 8.5' foreground='#FFFFFF'>   General</span>");
  gtk_widget_show (general_label);
  gtk_container_add (GTK_CONTAINER (general_label_bg), general_label);
  gtk_widget_set_size_request (general_label, -1, 21);
  gtk_label_set_use_markup (GTK_LABEL (general_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (general_label), 0, 0.8);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (vbox27), vbox28, FALSE, FALSE, 0);

  create_object = gtk_button_new ();
  gtk_widget_show (create_object);
  gtk_box_pack_start (GTK_BOX (vbox28), create_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (create_object), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(create_object, FALSE);
	
  alignment54 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment54);
  gtk_container_add (GTK_CONTAINER (create_object), alignment54);

  hbox93 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox93);
  gtk_container_add (GTK_CONTAINER (alignment54), hbox93);

  image260 = create_pixmap (PIXMAP_DIRECTORY "/Create_view.png");
  gtk_widget_show (image260);
  gtk_box_pack_start (GTK_BOX (hbox93), image260, FALSE, FALSE, 3);

  label297 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Create new view</span>");
  gtk_widget_show (label297);
  gtk_box_pack_start (GTK_BOX (hbox93), label297, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label297), TRUE);

  drop_object = gtk_button_new ();
  gtk_widget_show (drop_object);
  gtk_box_pack_start (GTK_BOX (vbox28), drop_object, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (drop_object), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(drop_object, FALSE);
	
  alignment55 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment55);
  gtk_container_add (GTK_CONTAINER (drop_object), alignment55);

  hbox94 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox94);
  gtk_container_add (GTK_CONTAINER (alignment55), hbox94);

  image261 = create_pixmap (PIXMAP_DIRECTORY "/Drop_view.png");
  gtk_widget_show (image261);
  gtk_box_pack_start (GTK_BOX (hbox94), image261, FALSE, FALSE, 3);

  label298 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Drop view</span>");
  gtk_widget_show (label298);
  gtk_box_pack_start (GTK_BOX (hbox94), label298, FALSE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label298), TRUE);

  apply_changes = gtk_button_new ();
  gtk_widget_set_name(apply_changes, "apply_changes");
  gtk_box_pack_start (GTK_BOX (vbox28), apply_changes, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (apply_changes), GTK_RELIEF_NONE);

  alignment56 = gtk_alignment_new (0, 0.5, 0, 0);
  gtk_widget_show (alignment56);
  gtk_container_add (GTK_CONTAINER (apply_changes), alignment56);

  hbox95 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox95);
  gtk_container_add (GTK_CONTAINER (alignment56), hbox95);

  image262 = create_pixmap (PIXMAP_DIRECTORY "/Apply.png");
  gtk_widget_show (image262);
  gtk_box_pack_start (GTK_BOX (hbox95), image262, FALSE, FALSE, 3);

  label299 = gtk_label_new ("<span font_desc='Tahoma 8.25' foreground='#000000'>Apply changes</span>");
  gtk_widget_show (label299);
  gtk_box_pack_start (GTK_BOX (hbox95), label299, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label299), TRUE);

  menu_bottom_bg = gtk_event_box_new ();
  gtk_widget_show (menu_bottom_bg);
  gtk_box_pack_start (GTK_BOX (menu), menu_bottom_bg, FALSE, TRUE, 0);

  menu_image = create_pixmap (PIXMAP_DIRECTORY "/Menu_bottom.png");
  gtk_widget_show (menu_image);
  gtk_misc_set_alignment (GTK_MISC (menu_image), 1, 0.5);
  gtk_container_add (GTK_CONTAINER (menu_bottom_bg), menu_image);
  
  // main window
  tab_view = gtk_notebook_new ();
  gtk_widget_show (tab_view);
   gtk_box_pack_start (GTK_BOX (tab_view_main), tab_view, TRUE, TRUE, 0);

  tab_view_vapend1 = gtk_vpaned_new ();
  gtk_widget_show (tab_view_vapend1);
  gtk_container_add (GTK_CONTAINER (tab_view), tab_view_vapend1);

  tab_view_vapend2 = gtk_vpaned_new ();
  gtk_widget_show (tab_view_vapend2);
  gtk_paned_pack1 (GTK_PANED (tab_view_vapend1), tab_view_vapend2, TRUE, TRUE);

  tab_view_objects = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_view_objects);
  gtk_paned_pack1 (GTK_PANED (tab_view_vapend2), tab_view_objects, TRUE, TRUE);

  tab_view_o_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_view_o_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_view_objects), tab_view_o_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_view_o_label_bg, -1, 21);

  hbox78 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox78);
  gtk_container_add (GTK_CONTAINER (tab_view_o_label_bg), hbox78);

  tab_view_o_label_img = create_pixmap(PIXMAP_DIRECTORY "/Schemas.png");
  gtk_widget_show (tab_view_o_label_img);
  gtk_box_pack_start (GTK_BOX (hbox78), tab_view_o_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_view_o_label_img), 0.52, 0.5);

  tab_view_o_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>label</span>");
  gtk_widget_show (tab_view_o_label);
  gtk_box_pack_start (GTK_BOX (hbox78), tab_view_o_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_view_o_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_view_o_label), 0, 0.99);

  tab_view_object_notebook = gtk_notebook_new ();
  gtk_widget_show (tab_view_object_notebook);
  gtk_box_pack_start (GTK_BOX (tab_view_objects), tab_view_object_notebook, TRUE, TRUE, 0);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (tab_view_object_notebook), GTK_POS_BOTTOM);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (tab_view_object_notebook), TRUE);

  scrolledwindow75 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow75);
  gtk_container_add (GTK_CONTAINER (tab_view_object_notebook), scrolledwindow75);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow75), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow75), GTK_SHADOW_IN);

  tab_view_fields = gtk_tree_view_new ();
  gtk_widget_show (tab_view_fields);
  gtk_container_add (GTK_CONTAINER (scrolledwindow75), tab_view_fields);

  tab_view_fields_label = gtk_label_new ("<span font_desc='8'>Fields</span>");
  gtk_widget_show (tab_view_fields_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view_object_notebook), 0), tab_view_fields_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_view_fields_label), TRUE);

  scrolledwindow76 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow76);
  gtk_container_add (GTK_CONTAINER (tab_view_object_notebook), scrolledwindow76);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow76), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow76), GTK_SHADOW_IN);

  tab_view_rules = gtk_tree_view_new ();
  gtk_widget_show (tab_view_rules);
  gtk_container_add (GTK_CONTAINER (scrolledwindow76), tab_view_rules);

  tab_view_rules_label = gtk_label_new ("<span font_desc='8'>Rules</span>");
  gtk_widget_show (tab_view_rules_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view_object_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view_object_notebook), 1), tab_view_rules_label);
  gtk_label_set_use_markup (GTK_LABEL (tab_view_rules_label), TRUE);

  tab_view_body = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_view_body);
  gtk_paned_pack2 (GTK_PANED (tab_view_vapend2), tab_view_body, TRUE, TRUE);

  tab_view_body_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_view_body_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_view_body), tab_view_body_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_view_body_label_bg, -1, 21);

  hbox79 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox79);
  gtk_container_add (GTK_CONTAINER (tab_view_body_label_bg), hbox79);

  tab_view_body_label_img = create_pixmap(PIXMAP_DIRECTORY "/SQL_editor.png");
  gtk_widget_show (tab_view_body_label_img);
  gtk_box_pack_start (GTK_BOX (hbox79), tab_view_body_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_view_body_label_img), 0.52, 0.5);

  tab_view_body_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Body</span>");
  gtk_widget_show (tab_view_body_label);
  gtk_box_pack_start (GTK_BOX (hbox79), tab_view_body_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_view_body_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_view_body_label), 0, 0.99);

  scrolledwindow78 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow78);
  gtk_box_pack_start (GTK_BOX (tab_view_body), scrolledwindow78, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow78), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow78), GTK_SHADOW_IN);

  tab_view_body_text = gtk_text_view_new ();
  gtk_widget_show (tab_view_body_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow78), tab_view_body_text);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_view_body_text), 7);

  tab_view_properties = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (tab_view_properties);
  gtk_paned_pack2 (GTK_PANED (tab_view_vapend1), tab_view_properties, FALSE, TRUE);

  tab_view_properties_label_bg = gtk_event_box_new ();
  gtk_widget_show (tab_view_properties_label_bg);
  gtk_box_pack_start (GTK_BOX (tab_view_properties), tab_view_properties_label_bg, FALSE, TRUE, 0);
  gtk_widget_set_size_request (tab_view_properties_label_bg, -1, 21);

  hbox74 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox74);
  gtk_container_add (GTK_CONTAINER (tab_view_properties_label_bg), hbox74);

  tab_view_properties_label_img = create_pixmap(PIXMAP_DIRECTORY "/Properties.png");
  gtk_widget_show (tab_view_properties_label_img);
  gtk_box_pack_start (GTK_BOX (hbox74), tab_view_properties_label_img, FALSE, TRUE, 5);
  gtk_misc_set_alignment (GTK_MISC (tab_view_properties_label_img), 0.52, 0.5);

  tab_view_properties_label = gtk_label_new ("<span font_desc='9 Bold' foreground='#FFFFFF'>Properties</span>");
  gtk_widget_show (tab_view_properties_label);
  gtk_box_pack_start (GTK_BOX (hbox74), tab_view_properties_label, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_view_properties_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_view_properties_label), 0, 0.99);

  scrolledwindow46 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow46);
  gtk_box_pack_start (GTK_BOX (tab_view_properties), scrolledwindow46, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow46), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow46), viewport1);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport1), GTK_SHADOW_NONE);
	
	GtkWidget * properties_background = gtk_event_box_new();
  gtk_widget_show (properties_background);
  gtk_container_add (GTK_CONTAINER (viewport1), properties_background);
  
  GtkWidget * properties_columns = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (properties_columns);
  gtk_container_add (GTK_CONTAINER (properties_background), properties_columns);

  GtkWidget * properties_column1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column1);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column1, FALSE, TRUE, 0);
 
  GtkWidget * properties_column2 = gtk_vbox_new (FALSE, 1);
  gtk_widget_show (properties_column2);
  gtk_box_pack_start (GTK_BOX (properties_columns), properties_column2, TRUE, TRUE, 0);
	
  label208 = gtk_label_new ("<span font_desc='Italic 8'>Properties</span>");
  gtk_widget_show (label208);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view), 0), label208);
  gtk_label_set_use_markup (GTK_LABEL (label208), TRUE);

  data_tab = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (data_tab);
  gtk_container_add (GTK_CONTAINER (tab_view), data_tab);
	
	GtkWidget * data_tab_hr = gtk_event_box_new ();
	gtk_widget_show (data_tab_hr);
	gtk_box_pack_start (GTK_BOX (data_tab), data_tab_hr, FALSE, TRUE, 0);
	
  hbox96 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox96);
  gtk_container_add (GTK_CONTAINER (data_tab_hr), hbox96);

  eventbox3 = gtk_event_box_new ();
  gtk_widget_show (eventbox3);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox3, TRUE, TRUE, 0);

  insert_data = gtk_button_new ();
  gtk_widget_show (insert_data);
  gtk_box_pack_start (GTK_BOX (hbox96), insert_data, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, insert_data, "Insert", NULL);
	gtk_button_set_relief (GTK_BUTTON (insert_data), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(insert_data, FALSE);
		
  alignment57 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment57);
  gtk_container_add (GTK_CONTAINER (insert_data), alignment57);

  hbox97 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox97);
  gtk_container_add (GTK_CONTAINER (alignment57), hbox97);

  image263 = gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image263);
  gtk_box_pack_start (GTK_BOX (hbox97), image263, FALSE, FALSE, 0);

  delete_data = gtk_button_new ();
  gtk_widget_show (delete_data);
  gtk_box_pack_start (GTK_BOX (hbox96), delete_data, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, delete_data, "Delete", NULL);
	gtk_button_set_relief (GTK_BUTTON (delete_data), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(delete_data, FALSE);
		
  alignment58 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment58);
  gtk_container_add (GTK_CONTAINER (delete_data), alignment58);

  hbox98 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox98);
  gtk_container_add (GTK_CONTAINER (alignment58), hbox98);

  image264 = gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image264);
  gtk_box_pack_start (GTK_BOX (hbox98), image264, FALSE, FALSE, 0);

  edit_data = gtk_button_new ();
  gtk_widget_show (edit_data);
  gtk_box_pack_start (GTK_BOX (hbox96), edit_data, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, edit_data, "Edit", NULL);
	gtk_button_set_relief (GTK_BUTTON (edit_data), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(edit_data, FALSE);
		
  alignment59 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment59);
  gtk_container_add (GTK_CONTAINER (edit_data), alignment59);

  hbox99 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox99);
  gtk_container_add (GTK_CONTAINER (alignment59), hbox99);

  image265 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image265);
  gtk_box_pack_start (GTK_BOX (hbox99), image265, FALSE, FALSE, 0);

  eventbox4 = gtk_event_box_new ();
  gtk_widget_show (eventbox4);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox4, TRUE, TRUE, 0);

  first = gtk_button_new ();
  gtk_widget_show (first);
  gtk_box_pack_start (GTK_BOX (hbox96), first, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (first), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(first, FALSE);
		
  alignment60 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment60);
  gtk_container_add (GTK_CONTAINER (first), alignment60);

  hbox100 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox100);
  gtk_container_add (GTK_CONTAINER (alignment60), hbox100);

  image266 = gtk_image_new_from_stock ("gtk-goto-first", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image266);
  gtk_box_pack_start (GTK_BOX (hbox100), image266, FALSE, FALSE, 0);

  previous = gtk_button_new ();
  gtk_widget_show (previous);
  gtk_box_pack_start (GTK_BOX (hbox96), previous, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (previous), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(previous, FALSE);
		
  alignment61 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment61);
  gtk_container_add (GTK_CONTAINER (previous), alignment61);

  hbox101 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox101);
  gtk_container_add (GTK_CONTAINER (alignment61), hbox101);

  image267 = gtk_image_new_from_stock ("gtk-go-back", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image267);
  gtk_box_pack_start (GTK_BOX (hbox101), image267, FALSE, FALSE, 0);

  limit_count_adj = gtk_adjustment_new (1000, 1, 60000, 100, 10, 10);
  limit_count = gtk_spin_button_new (GTK_ADJUSTMENT (limit_count_adj), 1, 0);
  gtk_widget_show (limit_count);
  gtk_box_pack_start (GTK_BOX (hbox96), limit_count, FALSE, FALSE, 0);
  gtk_widget_set_size_request (limit_count, 80, -1);
  gtk_tooltips_set_tip (tooltips, limit_count, "Limit count", NULL);
	g_object_set (limit_count, "has_frame", FALSE, NULL);
	gtk_widget_set_sensitive(limit_count, FALSE);
		
  next = gtk_button_new ();
  gtk_widget_show (next);
  gtk_box_pack_start (GTK_BOX (hbox96), next, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (next), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(next, FALSE);
		
  alignment62 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment62);
  gtk_container_add (GTK_CONTAINER (next), alignment62);

  hbox102 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox102);
  gtk_container_add (GTK_CONTAINER (alignment62), hbox102);

  image268 = gtk_image_new_from_stock ("gtk-go-forward", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image268);
  gtk_box_pack_start (GTK_BOX (hbox102), image268, FALSE, FALSE, 0);

  last = gtk_button_new ();
  gtk_widget_show (last);
  gtk_box_pack_start (GTK_BOX (hbox96), last, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (last), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(last, FALSE);
		
  alignment63 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment63);
  gtk_container_add (GTK_CONTAINER (last), alignment63);

  hbox103 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox103);
  gtk_container_add (GTK_CONTAINER (alignment63), hbox103);

  image269 = gtk_image_new_from_stock ("gtk-goto-last", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image269);
  gtk_box_pack_start (GTK_BOX (hbox103), image269, FALSE, FALSE, 0);

  eventbox5 = gtk_event_box_new ();
  gtk_widget_show (eventbox5);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox5, TRUE, TRUE, 0);

  fetch_all = gtk_button_new ();
  gtk_widget_show (fetch_all);
  gtk_box_pack_start (GTK_BOX (hbox96), fetch_all, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, fetch_all, "Fetch all records", NULL);
	gtk_button_set_relief (GTK_BUTTON (fetch_all), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive(fetch_all, FALSE);
		
  alignment64 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment64);
  gtk_container_add (GTK_CONTAINER (fetch_all), alignment64);

  hbox104 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox104);
  gtk_container_add (GTK_CONTAINER (alignment64), hbox104);

  image270 = gtk_image_new_from_stock ("gtk-goto-bottom", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image270);
  gtk_box_pack_start (GTK_BOX (hbox104), image270, FALSE, FALSE, 0);

  fetch_filtered = gtk_button_new ();
  gtk_widget_show (fetch_filtered);
  gtk_box_pack_start (GTK_BOX (hbox96), fetch_filtered, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, fetch_filtered, "Fetch filtered records", NULL);
	gtk_button_set_relief (GTK_BUTTON (fetch_filtered), GTK_RELIEF_NONE);
	gtk_widget_set_sensitive( fetch_filtered, FALSE);
		
  alignment65 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment65);
  gtk_container_add (GTK_CONTAINER (fetch_filtered), alignment65);

  hbox105 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox105);
  gtk_container_add (GTK_CONTAINER (alignment65), hbox105);

  image271 = gtk_image_new_from_stock ("gtk-go-down", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image271);
  gtk_box_pack_start (GTK_BOX (hbox105), image271, FALSE, FALSE, 0);

  eventbox6 = gtk_event_box_new ();
  gtk_widget_show (eventbox6);
  gtk_box_pack_start (GTK_BOX (hbox96), eventbox6, TRUE, TRUE, 0);

  scrolledwindow136 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow136);
  gtk_box_pack_start (GTK_BOX (data_tab), scrolledwindow136, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow136), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow136), GTK_SHADOW_IN);

  data_view = gtk_tree_view_new ();
  gtk_widget_show (data_view);
  gtk_container_add (GTK_CONTAINER (scrolledwindow136), data_view);

  label209 = gtk_label_new ("<span font_desc='Italic 8'>Data</span>");
  gtk_widget_show (label209);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view), 1), label209);
  gtk_label_set_use_markup (GTK_LABEL (label209), TRUE);

  tab_view_depen_hpend = gtk_hpaned_new ();
  gtk_widget_show (tab_view_depen_hpend);
  gtk_container_add (GTK_CONTAINER (tab_view), tab_view_depen_hpend);
  gtk_paned_set_position (GTK_PANED (tab_view_depen_hpend), -1);

  scrolledwindow71 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow71);
  gtk_paned_pack1 (GTK_PANED (tab_view_depen_hpend), scrolledwindow71, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow71), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow71), GTK_SHADOW_IN);

  tab_view_depen_dep_on = gtk_tree_view_new ();
  gtk_widget_show (tab_view_depen_dep_on);
  gtk_container_add (GTK_CONTAINER (scrolledwindow71), tab_view_depen_dep_on);

  scrolledwindow72 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow72);
  gtk_paned_pack2 (GTK_PANED (tab_view_depen_hpend), scrolledwindow72, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow72), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow72), GTK_SHADOW_IN);

  tab_view_depen_ref_by = gtk_tree_view_new ();
  gtk_widget_show (tab_view_depen_ref_by);
  gtk_container_add (GTK_CONTAINER (scrolledwindow72), tab_view_depen_ref_by);

  label210 = gtk_label_new ("<span font_desc='Italic 8'>Dependencies</span>");
  gtk_widget_show (label210);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view), 2), label210);
  gtk_label_set_use_markup (GTK_LABEL (label210), TRUE);

  scrolledwindow73 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow73);
  gtk_container_add (GTK_CONTAINER (tab_view), scrolledwindow73);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow73), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow73), GTK_SHADOW_IN);

  tab_view_permissions = gtk_tree_view_new ();
  gtk_widget_show (tab_view_permissions);
  gtk_container_add (GTK_CONTAINER (scrolledwindow73), tab_view_permissions);

  label211 = gtk_label_new ("<span font_desc='Italic 8'>Permissions</span>");
  gtk_widget_show (label211);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view), 3), label211);
  gtk_label_set_use_markup (GTK_LABEL (label211), TRUE);

  scrolledwindow74 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow74);
  gtk_container_add (GTK_CONTAINER (tab_view), scrolledwindow74);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow74), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow74), GTK_SHADOW_IN);

  tab_view_sql_code = gtk_text_view_new ();
  gtk_widget_show (tab_view_sql_code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow74), tab_view_sql_code);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (tab_view_sql_code), 7);

  label212 = gtk_label_new ("<span font_desc='Italic 8'>SQL</span>");
  gtk_widget_show (label212);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (tab_view), gtk_notebook_get_nth_page (GTK_NOTEBOOK (tab_view), 4), label212);
  gtk_label_set_use_markup (GTK_LABEL (label212), TRUE);

  // create page label
 	GtkWidget *tab_l;
  GtkWidget *tab_icon;
  GtkWidget *tab_label;
  GtkWidget *tab_b;
  GtkWidget *tab_close;
  GtkWidget *image181;
  
  tab_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (tab_l, "tab_l");
  gtk_widget_show (tab_l);
 
  tab_icon = create_pixmap (PIXMAP_DIRECTORY "/Table.png");
  gtk_widget_show (tab_icon);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_icon, TRUE, TRUE, 0);
  gtk_widget_set_size_request (tab_icon, 20, 20);
  gtk_misc_set_alignment (GTK_MISC (tab_icon), 0.5, 0.44);
  
  gchar *text = bold_text(view->name, "#000000");
  tab_label = gtk_label_new (text);
  free(text);
  gtk_widget_show (tab_label);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_label, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (tab_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (tab_label), 1, 0.5);

  tab_b = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (tab_b);
  gtk_box_pack_start (GTK_BOX (tab_l), tab_b, FALSE, FALSE, 0);
  gtk_alignment_set_padding (GTK_ALIGNMENT (tab_b), 0, 0, 10, 0);

  tab_close = gtk_button_new ();
  gtk_widget_show (tab_close);
  gtk_container_add (GTK_CONTAINER (tab_b), tab_close);
  gtk_widget_set_size_request (tab_close, 20, 20);
  gtk_tooltips_set_tip (tooltips, tab_close, "Close Table Info", NULL);
  gtk_button_set_relief (GTK_BUTTON (tab_close), GTK_RELIEF_NONE);
 
  image181 = create_pixmap (PIXMAP_DIRECTORY "/Close.png");
  gtk_widget_show (image181);
  gtk_container_add (GTK_CONTAINER (tab_close), image181);
  
  // Modify colors 
	GdkColor color;
	
	// menu colors
	color.red = 132*257;
  color.green = 5*257;
  color.blue = 5*257;
  gtk_widget_modify_bg (menu_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (menu_bottom_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (object_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_bg, GTK_STATE_NORMAL, &color);
  
	color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
  gtk_widget_modify_bg (object_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (database_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (general_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (tab_view_body_label_bg, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox3, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox4, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox5, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (eventbox6, GTK_STATE_NORMAL, &color);    
  
  // Show properties	
	gint height = 0;
	add_header_proper(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Common",  PIXMAP_DIRECTORY "/Common.png");
	height += 21;
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Name",  view->name);
	height += 21;	
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Owner", view->owner);
	height += 21;	
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "Comment", view->comment);
	height += 21;
	text = itoa_n(view->OID, 0);
	add_noneditable_property(GTK_BOX(properties_column1), GTK_BOX(properties_column2), "OID", text);
	free(text);
	height += 21;
	gtk_widget_set_size_request (scrolledwindow46, -1, height);	
  
  // show sub objects
	// fields
	gint n = view->n_columns;
	
	GType types[5];
	types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_view_fields), 0);
	types[1] = GDK_TYPE_PIXBUF;
	types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_view_fields), "Name", 1);
	types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_view_fields), "Type", 3);
	types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_view_fields),"Comment", 4);
	GtkTreeModel * model = GTK_TREE_MODEL(gtk_list_store_newv(5, types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(view->column[i]->name,"#980F0F");
		gchar * text2 = normal_text(view->column[i]->type);
		gchar * text3 = normal_text(view->column[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Field.png"), 2, text1, 3, text2, 4, text3, -1);
		free(t); free(text); free(text1); free(text2); free(text3);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_view_fields)), model);
  
  // rules
	n = view->n_rules;
	
	GType rul_types[5];
	rul_types[0] = G_TYPE_STRING;
	add_row_number_column(GTK_TREE_VIEW(tab_view_rules), 0);
	rul_types[1] = GDK_TYPE_PIXBUF;
	rul_types[2] = G_TYPE_STRING;
	add_icon_column(GTK_TREE_VIEW(tab_view_rules), "Name", 1);
	rul_types[3] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_view_rules), "Event", 3);
	rul_types[4] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_view_rules),"Instead", 4);
	rul_types[5] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_view_rules),"Condition", 5);
	rul_types[6] = G_TYPE_STRING;
	add_text_column(GTK_TREE_VIEW(tab_view_rules),"Comment", 6);
	
	model = GTK_TREE_MODEL(gtk_list_store_newv(7, rul_types));
	
	for(int i=0; i < n; i++){
		GtkTreeIter iter;
		gtk_list_store_append(GTK_LIST_STORE(model), &iter);
		gchar * t = itoa_n( i+1 ,0);
		gchar * text = normal_text_with_color(t, "#000000");
		gchar * text1 = normal_text_with_color(view->rule[i]->name,"#980F0F");
		gchar * text2 = normal_text(view->rule[i]->event);
		gchar * text3 = normal_text((view->rule[i]->instead) ? "True" : "False");
		gchar * text4 = normal_text(view->rule[i]->condition);
		gchar * text5 = normal_text(view->rule[i]->comment);
		gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, text, 1, get_icon(PIXMAP_DIRECTORY "/Rule.png"), 2, text1, 3, text2, 4, text3, 5, text4, 6, text5, -1);
		free(t); free(text); free(text1); free(text2); free(text3); free(text4); free(text5);
	}
	gtk_tree_view_set_model(GTK_TREE_VIEW(GTK_TREE_VIEW(tab_view_rules)), model);
	
  // init body
  init_text_view(tab_view_body_text, FALSE, view->body);
   
  // show dependencies
	show_dependencies(GTK_TREE_VIEW(tab_view_depen_dep_on), GTK_TREE_VIEW(tab_view_depen_ref_by), &(view->dep_on), &(view->ref_by));
	
	//init sql code textview
	init_text_view( tab_view_sql_code, FALSE, "-- SQL code");
	
  // main colors
  color.red = 128*257;
  color.green = 128*257;
  color.blue = 128*257;  
	gtk_widget_modify_bg (tab_view_o_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (tab_view_properties_label_bg, GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (data_tab_hr, GTK_STATE_NORMAL, &color);
  
	color.red = 236*257;
  color.green = 232*257;
  color.blue = 226*257;  
  gtk_widget_modify_bg (properties_background, GTK_STATE_NORMAL, &color);
  
  // connect signals
	g_signal_connect ((gpointer) tab_close, "clicked",
                    G_CALLBACK (on_tab_close_clicked),
                    tab_view_main);
              
  g_signal_connect ((gpointer) tab_view_object_notebook, "switch-page",
                    G_CALLBACK (on_tab_view_objects_change_current_page),
                    hbox78);
  
  // create page struct and append it to global list
	T_Page * page;
	T_Page * existing_page;
	
	if((page = (T_Page *) malloc(sizeof(T_Page))) == NULL){
	   	fprintf(stderr, "Memory allocation error.");
	 		exit(0);
	}
	
	page->modified = FALSE;
	page->page = tab_view_main;
	page->path = path;
	page->object = view;
	page->close_function = on_tab_close_clicked;
	
	if(!append_page_to_list(&notebook, page, &existing_page)){
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), existing_page->page));
	}
	else{
		// add page to main_notebook
		gtk_container_add (GTK_CONTAINER (main_notebook), page->page);
		gtk_notebook_set_tab_label (GTK_NOTEBOOK (main_notebook), page->page, tab_l);
		gtk_notebook_set_menu_label_text(GTK_NOTEBOOK(main_notebook), page->page, view->name);
	
		// set current page in main notebook
		gtk_notebook_set_current_page (GTK_NOTEBOOK(tab_view_object_notebook), 1);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(tab_view_object_notebook), 0);
		gtk_notebook_set_current_page (GTK_NOTEBOOK(main_notebook), gtk_notebook_page_num (GTK_NOTEBOOK(main_notebook), page->page));
	}  
}// create_view_info()

/*
 * Subobject notebook page changed
 */
void
on_tab_view_objects_change_current_page (GtkNotebook *nb, GtkNotebookPage *page, guint page_num, gpointer user_data)
{
	GList * children = gtk_container_get_children(GTK_CONTAINER(user_data));
	GtkWidget * label = NULL;
	GtkWidget * image = NULL;
	do{
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_LABEL) label = children->data;
		if(GTK_WIDGET_TYPE(children->data) == GTK_TYPE_IMAGE) image = children->data;
		children = children->next;
 	}while(children != NULL);
	
	switch(page_num){
	  case 0: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Fields.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Fields</span>");
									break;
		case 1: gtk_image_set_from_file (GTK_IMAGE(image), PIXMAP_DIRECTORY "/Rules.png");
	  							gtk_label_set_markup(GTK_LABEL(label), "<span font_desc='9 Bold' foreground='#FFFFFF'>Rules</span>");
									break;
		}
} // on_tab_view_objects_change_current_page ()
