/*
 * C source file for program pguiman - PostgreSQL Manager
 *
 * Copyright (C) 2007 Dvoracek Ondrej
 *
 * Dvoracek Ondrej <odvorace@redhat.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 *
 */

#include "db_profile_wizard.h"
#include "../functions.h"
#include "../database/db_connection.h"
#include "../database/get_db_objects.h"
#include "../otree/show_otree.h"
#include "../tools/db_profile_manager.h"
#include "../tools/sql_editor.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*						Create database profile wizard                                                                          */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void init_c_db_profile_wizard(void){
	// Color settings
	GdkColor color;
	color.red = 255*257;
  color.green = 255*257;
  color.blue = 255*257;  
  gtk_widget_modify_bg (glade_xml_get_widget(xml,"cdbp1_head"), GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (glade_xml_get_widget(xml,"cdbp2_head"), GTK_STATE_NORMAL, &color);
  gtk_widget_modify_bg (glade_xml_get_widget(xml,"cdbp3_head"), GTK_STATE_NORMAL, &color);

	color.red = 204*257;
  color.green = 0*257;
  color.blue = 0*257;  
	gtk_widget_modify_bg (glade_xml_get_widget(xml,"cdbp1_hr"), GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (glade_xml_get_widget(xml,"cdbp2_hr"), GTK_STATE_NORMAL, &color);
	gtk_widget_modify_bg (glade_xml_get_widget(xml,"cdbp3_hr"), GTK_STATE_NORMAL, &color);


	// Init listviews ...
	create_database_list_view(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"));
	gtk_tree_view_column_set_title(gtk_tree_view_get_column(GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs")),0), "Available databases");

	create_database_list_view(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"));
	gtk_tree_view_column_set_title(gtk_tree_view_get_column(GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs")),0), "Selected databases");

	create_alias_list_view(glade_xml_get_widget(xml,"cdbp3_tw_aliases"));
	gtk_tree_view_column_set_title(gtk_tree_view_get_column(GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp3_tw_aliases")),0), "Database");
	gtk_tree_view_column_set_title(gtk_tree_view_get_column(GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp3_tw_aliases")),1), "Alias");
} 

void run_c_db_profile_wizard(void){
	GtkWidget * widget = NULL;
	gint page = 1;
	gboolean not_end = TRUE;
	
	// intit input widgets
	gtk_entry_set_text( GTK_ENTRY( glade_xml_get_widget(xml,"cdbp1_en_hname") ), "");
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(glade_xml_get_widget(xml, "cdbp1_sp_pnum")), (gdouble)5432);
	gtk_entry_set_text( GTK_ENTRY( glade_xml_get_widget(xml,"cdbp1_en_uname") ), "");
	gtk_entry_set_text( GTK_ENTRY( glade_xml_get_widget(xml,"cdbp1_en_passwd") ), "");
	gtk_combo_box_set_active(GTK_COMBO_BOX(glade_xml_get_widget(xml,"cdbp1_co_ssl")), 2);
	
	// set sensitivity
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_next"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp3_bt_ready"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_all_dbs"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_db"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_db"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_all_dbs"), FALSE);
	
	
	// clear list views
	gtk_list_store_clear(GTK_LIST_STORE(gtk_tree_view_get_model (GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs")))));
	gtk_list_store_clear(GTK_LIST_STORE(gtk_tree_view_get_model (GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs")))));
	gtk_list_store_clear(GTK_LIST_STORE(gtk_tree_view_get_model (GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp3_tw_aliases")))));

	while(not_end){
		switch(page){
			case 1:	widget = glade_xml_get_widget(xml,"c_db_profile_wiz1"); break;
			case 2: widget = glade_xml_get_widget(xml,"c_db_profile_wiz2"); break;
			case 3: widget = glade_xml_get_widget(xml,"c_db_profile_wiz3"); break;
			default:;
		};
		gint res = gtk_dialog_run(GTK_DIALOG(widget));
		
		if(res == GTK_RESPONSE_YES){
			if(page < 3){
				if(page == 1){ // try create to connect to get databases

					if(get_existing_dbs(
																			(char *)gtk_entry_get_text( GTK_ENTRY( glade_xml_get_widget(xml,"cdbp1_en_hname") ) ),
																			itoa_n(gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(glade_xml_get_widget(xml,"cdbp1_sp_pnum"))),0),
																			(char *)gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml,"cdbp1_en_uname"))),
																			(char *)gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml,"cdbp1_en_passwd"))),
																			itoa_n(gtk_combo_box_get_active(GTK_COMBO_BOX(glade_xml_get_widget(xml,"cdbp1_co_ssl"))),0)																			
																		)){
																				page++;
  				 															gtk_widget_hide(widget);
																			}		 
				}
				else if(page == 2){
					 page++;
					 show_choosen_databases();
  				 gtk_widget_hide(widget);
				}
				else{
					 page++;
  				 gtk_widget_hide(widget);
				}
			}
			else{ // end the wizard
					not_end = FALSE;
					// Create profiles
					GtkTreeIter iter;
					GtkTreeView * view = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp3_tw_aliases"));
					GtkTreeModel * model = gtk_tree_view_get_model(view);
					gchar * dbname;
					gchar * alias;
					if(gtk_tree_model_get_iter_first(model,&iter)){
						do{
							gtk_tree_model_get(model, &iter, COL_TEXT, &dbname, COL_TEXT+1, &alias, -1);
							create_db_profile(
																					copy_string(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml,"cdbp1_en_hname")))),
		                                      (guint) gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(glade_xml_get_widget(xml,"cdbp1_sp_pnum"))),
		                                      copy_string(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml,"cdbp1_en_uname")))),
	                                        copy_string(""),
	                                        (guint) gtk_combo_box_get_active(GTK_COMBO_BOX(glade_xml_get_widget(xml,"cdbp1_co_ssl"))),
	                                        copy_string(dbname), 
	                                        copy_string(alias)
																					);
						}while(gtk_tree_model_iter_next(model,&iter));
					}
					show_object_tree();
					refresh_profile_manager();
					refresh_sql_editor();
					gtk_widget_hide(widget);
			}
		}
		else if(res == GTK_RESPONSE_NO){
			if(page > 1){
				page--;
				gtk_widget_hide(widget);
			}
		}
		else if(res == GTK_RESPONSE_CANCEL || res == GTK_RESPONSE_DELETE_EVENT){
				not_end = FALSE;
				gtk_widget_hide(widget);
		}
	}
}

gboolean
get_existing_dbs(gchar * host, gchar * port, gchar * uname, gchar * passwd, gchar * SSL)
{
 PGconn * conn;
	/* Connection to database */
	char * conninfo = make_conninfo(host, port, "postgres", uname, passwd, (guint) atoi(SSL));

	// trying connection
	if((conn = connect_db(conninfo)) != NULL) ;
  else return FALSE;
  free(conninfo);
	
	/* Get databases */
	gint row, rows;
	
	gchar ** list;
	list = get_database_list(conn, TRUE, FALSE, &rows);
	
	GtkListStore   *store;
  GtkTreeIter       iter;
  GdkPixbuf       *icon;
 
	store= GTK_LIST_STORE( gtk_tree_view_get_model (GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"))) );
	gtk_list_store_clear(store);
	
	store= GTK_LIST_STORE( gtk_tree_view_get_model (GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"))) );
	gtk_list_store_clear(store);

	for (row = 0; row < rows; row++){
	  icon = get_icon(PIXMAP_DIRECTORY "/Database.png");
    
    gtk_list_store_append(store, &iter);

    gtk_list_store_set(store, &iter,
                       COL_ICON, icon,
                       COL_TEXT, list[row],
                       -1);
     free(list[row]);
	}
	
	free(list);
	
	//Select first row
	if(gtk_tree_model_get_iter_first( gtk_tree_view_get_model (GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"))), &iter)){
		GtkTreeSelection * selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs")));
		gtk_tree_selection_select_iter (selection, &iter);
	}
	
	if(row > 0){
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_all_dbs"), TRUE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_db"), TRUE);
	}
	
	disconnect_db(conn);
	return TRUE;
}

void
create_database_list_view     (GtkWidget * view)
{
    GtkTreeModel      *model;
    GtkTreeViewColumn *col;
    GtkCellRenderer   *renderer;

    model = GTK_TREE_MODEL(gtk_list_store_new(NUM_COLS, GDK_TYPE_PIXBUF, G_TYPE_STRING));
    
    gtk_tree_view_set_model(GTK_TREE_VIEW(view), model);
		
    col = gtk_tree_view_column_new();
    
    renderer = gtk_cell_renderer_pixbuf_new();
    gtk_tree_view_column_pack_start(col, renderer, FALSE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "pixbuf", COL_ICON,
                                        NULL);

    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_column_pack_start(col, renderer, TRUE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "text", COL_TEXT,
                                        NULL);

    gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);
    
    gtk_widget_show_all(view);
}

void
create_alias_list_view     (GtkWidget * view)
{
    GtkTreeModel      *model;
    GtkTreeViewColumn *col;
    GtkCellRenderer   *renderer;

    model = GTK_TREE_MODEL(gtk_list_store_new(NUM_COLS+1, GDK_TYPE_PIXBUF, G_TYPE_STRING,  G_TYPE_STRING));
    
    gtk_tree_view_set_model(GTK_TREE_VIEW(view), model);
		
    col = gtk_tree_view_column_new();
    
    renderer = gtk_cell_renderer_pixbuf_new();
    gtk_tree_view_column_pack_start(col, renderer, FALSE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "pixbuf", COL_ICON,
                                        NULL);

    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_column_pack_start(col, renderer, TRUE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "text", COL_TEXT,
                                        NULL);

    gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

                                        
    col = gtk_tree_view_column_new();
    
    renderer = gtk_cell_renderer_text_new();
    g_object_set(renderer, "editable", TRUE, NULL);
    g_object_set(renderer,"weight", PANGO_WEIGHT_BOLD, "weight-set", TRUE,NULL);
    g_signal_connect(renderer, "edited", (GCallback) alias_edited_callback, NULL);
    gtk_tree_view_column_pack_start(col, renderer, TRUE);
    gtk_tree_view_column_set_attributes(col, renderer,
                                        "text", COL_TEXT+1,
                                        NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(view), col);

    gtk_widget_show_all(view);
}

void
show_choosen_databases(void)
{
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"));
	GtkTreeView * view2 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp3_tw_aliases"));
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;

	gtk_list_store_clear(GTK_LIST_STORE(model2));
	if(gtk_tree_model_get_iter_first(model1,&iter)){
			do{
			gtk_tree_model_get(model1, &iter, COL_TEXT, &value,-1);
		
			GtkListStore   *store;
  		GdkPixbuf       *icon;
  
			store= GTK_LIST_STORE(model2);
			
			icon = get_icon(PIXMAP_DIRECTORY "/Database.png");

    	gint n = strlen(value) + strlen("@") + strlen(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "cdbp1_en_hname"))));
      gchar * alias = alloc_string(n+1);
      strcpy(alias, value);
      strcat(alias, "@");
      strcat(alias, gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "cdbp1_en_hname"))));
      
			gtk_list_store_append(store, &new);

    	gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       COL_TEXT+1, alias,
                       -1);
		  }while(gtk_tree_model_iter_next(model1,&iter));
	
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp3_bt_ready"), TRUE);
	}
}

void
create_db_profile(
																gchar * hname,	// server properties
																guint port, 
																gchar * uname,
																gchar * passwd,
																guint SSL,
																gchar * dbname,	// profile properties
																gchar *alias
															)
{
	// Add server
	T_Server * server;
	
	/* Test if known server */
	gboolean known = FALSE;
	gint index;
	gint n_servers = o_tree.n_servers;
	for(int i=0; i < n_servers; i++){
		server = o_tree.server[i];
		if(strcmp(server->host, hname) == 0 &&  strcmp(server->uname, uname) == 0 && server->port == port){
			index = i;
			known= TRUE;
			break;
		}
	}
	
	if(known){ // if known server actualize only SSL
		server  = o_tree.server[index];
		server->SSL = SSL;
	}
	else{	// create new server struct
		server = NULL;
		
		// resize array of servers
		if(o_tree.server == NULL){ // malloc new server array
	
			 if((o_tree.server = (T_Server **) malloc(sizeof(T_Server*))) == NULL){
	 	  	 fprintf(stderr, "Memory allocation error.");
	       exit(0);
	     }
	  }
		else{ // realloc server array
	  	if((o_tree.server = (T_Server **) realloc((o_tree.server), sizeof(T_Server*)*(o_tree.n_servers+1))) == NULL){
	 	    fprintf(stderr, "Memory allocation error.");
	      exit(0);
	    }
		}	
		
		if((o_tree.server[o_tree.n_servers] = (T_Server*) malloc(sizeof(T_Server))) == NULL){
	 	  fprintf(stderr, "Memory allocation error: callbacks.c");
	    exit(0);
		}
		
		index = o_tree.n_servers;
		server = o_tree.server[o_tree.n_servers];
		server->profile = NULL;
		server->n_profiles = 0;
		server->role = NULL;
		server->n_roles = 0;
		server->tablespace = NULL;
		server->n_tablespaces = 0;
		server->host = hname;
		server->uname =uname;
		server->passwd =passwd;
		server->port	= port;
		server->SSL = SSL;

		// Make server name
		gint len = strlen(server->uname) + strlen("@") + strlen(server->host);
  	o_tree.server[o_tree.n_servers]->name = alloc_string(len + 1);
  	o_tree.server[o_tree.n_servers]->name[0] = '\0';
  	strcat(server->name, server->uname); strcat(server->name, "@"); strcat(server->name, server->host);

		// Increment number of servers
		o_tree.n_servers++;
	}
	
	// Add profiles
	
	T_Profile * profile;

	/* Test if known profile */
	known = FALSE;
	gint p_index;
	gint n_profiles = o_tree.server[index]->n_profiles;
	for(int i=0; i < n_profiles; i++){
		profile = o_tree.server[index]->profile[i];
		if(strcmp(profile->dbname, dbname) == 0){
			p_index = i;
			known= TRUE;
			break;
		}
	}
	
	if(!known){	// create new server struct
		if(o_tree.server[index]->profile == NULL){ // malloc new profile array
		  if((o_tree.server[index]->profile = (T_Profile **) malloc(sizeof(T_Profile*))) == NULL){
		    fprintf(stderr, "Memory allocation error.");
	      exit(0);
	    }
	  }
	  else{ // realloc server array
	 	  if((o_tree.server[index]->profile = (T_Profile **) realloc((o_tree.server[index]->profile), sizeof(T_Profile*)*(o_tree.server[index]->n_profiles+1))) == NULL){
		    fprintf(stderr, "Memory allocation error.");
	  	  exit(0);
		  }
	  }
	
		if((o_tree.server[index]->profile[o_tree.server[index]->n_profiles] = (T_Profile*) malloc(sizeof(T_Profile))) == NULL){
		  fprintf(stderr, "Memory allocation error: callbacks.c");
		  exit(0);
		}
		
		// initialization
		profile = o_tree.server[index]->profile[o_tree.server[index]->n_profiles];
		profile->dbname = dbname;
		profile->alias = alias;
		profile->connected = FALSE;
		profile->conn = NULL;
		profile->database.schema = NULL;
		profile->database.n_schemas = 0;
		profile->database.cast = NULL;
		profile->database.n_casts = 0;
		profile->database.language = NULL;
		profile->database.n_languages = 0;
			
  	// increment number of profiles
		o_tree.server[index]->n_profiles++;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* Callbacks for create db profile wizard                                                                          */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
connect_cdbp_wiz_signals(GladeXML * source)
{
	GtkWidget * widget;
  
	// Select all dbs
	widget = glade_xml_get_widget(source, "cdbp2_bt_add_all_dbs");
	g_signal_connect_swapped ((gpointer) widget, "clicked",
                    G_CALLBACK (on_cdbp2_bt_add_all_dbs_activate),
                    NULL);

	// Select selected db
	widget = glade_xml_get_widget(source, "cdbp2_bt_add_db");
	g_signal_connect_swapped ((gpointer) widget, "clicked",
                    G_CALLBACK (on_cdbp2_bt_add_db_activate),
                    NULL);
                    
	// Remove selected db
	widget = glade_xml_get_widget(source, "cdbp2_bt_remove_db");
	g_signal_connect_swapped((gpointer) widget, "clicked",
                    G_CALLBACK (on_cdbp2_bt_remove_db_activate),
                    NULL);


	// Remove all dbs
	widget = glade_xml_get_widget(source, "cdbp2_bt_remove_all_dbs");
	g_signal_connect_swapped ((gpointer) widget, "clicked",
                    G_CALLBACK (on_cdbp2_bt_remove_all_dbs_activate),
                    NULL);
}

void
on_cdbp2_bt_add_all_dbs_activate                       (GtkButton     *button, gpointer         user_data)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_all_dbs"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_db"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_db"), TRUE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_all_dbs"), TRUE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_next"), TRUE);
	
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"));
	GtkTreeView * view2 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"));
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;
	
	while(gtk_tree_model_get_iter_first(model1,&iter)){
		gtk_tree_model_get(model1, &iter, COL_TEXT, &value,-1);
		
		GtkListStore   *store;
  	GdkPixbuf       *icon;
		
		store= GTK_LIST_STORE(model2);
			
	  icon = get_icon(PIXMAP_DIRECTORY "/Database.png");
    
		gtk_list_store_append(store, &new);

    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		gtk_list_store_remove(GTK_LIST_STORE(model1), &iter);
	}
	
	gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view2), &new);
}

void
on_cdbp2_bt_add_db_activate                              (GtkButton     *button, gpointer         user_data)
{
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"));
	GtkTreeView * view2 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"));
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;
	
	if(gtk_tree_selection_get_selected(gtk_tree_view_get_selection(view1), &model1, &iter)){
		gtk_tree_model_get(model1, &iter, COL_TEXT, &value,-1);
		
		GtkListStore   *store;
  	GdkPixbuf       *icon;
		
		store= GTK_LIST_STORE(model2);
			
	  icon = get_icon(PIXMAP_DIRECTORY "/Database.png");
        
		gtk_list_store_append(store, &new);

    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		gtk_list_store_remove(GTK_LIST_STORE(model1), &iter);
		gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view2), &new);
	}
	
	if(!gtk_tree_model_get_iter_first(model1,&iter)){
		// seznam je prazdny
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_all_dbs"), FALSE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_db"), FALSE);
	}
	else{
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_all_dbs"), TRUE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_db"), TRUE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_next"), TRUE);
		gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view1), &iter);
	}
	
}

void
on_cdbp2_bt_remove_db_activate                       (GtkButton     *button, gpointer         user_data)
{
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"));
	GtkTreeView * view2 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"));
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;
	
	if(gtk_tree_selection_get_selected(gtk_tree_view_get_selection(view1), &model1, &iter)){
		gtk_tree_model_get(model1, &iter, COL_TEXT, &value,-1);
		
		GtkListStore   *store;
  	GdkPixbuf       *icon;
		
		store= GTK_LIST_STORE(model2);
			
	  icon = get_icon(PIXMAP_DIRECTORY "/Database.png");
   
		gtk_list_store_append(store, &new);

    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		gtk_list_store_remove(GTK_LIST_STORE(model1), &iter);
	}
	
	if(!gtk_tree_model_get_iter_first(model1,&iter)){
		// seznam je prazdny
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_all_dbs"), FALSE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_db"), FALSE);
  	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_next"), FALSE);
	}
	else{
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_all_dbs"), TRUE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_db"), TRUE);
		gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_next"), TRUE);
		gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view1), &iter);
	}
	gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view2), &new);
}

void
on_cdbp2_bt_remove_all_dbs_activate                (GtkButton     *button, gpointer         user_data)
{
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_all_dbs"), TRUE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_add_db"), TRUE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_db"),FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_remove_all_dbs"), FALSE);
	gtk_widget_set_sensitive(glade_xml_get_widget(xml,"cdbp2_bt_next"), FALSE);
	
	GtkTreeIter iter, new;
	GtkTreeView * view1 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_choosen_dbs"));
	GtkTreeView * view2 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp2_tw_available_dbs"));
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	GtkTreeModel * model2 = gtk_tree_view_get_model(view2);
	gchar * value;
	
	while(gtk_tree_model_get_iter_first(model1,&iter)){
		gtk_tree_model_get(model1, &iter, COL_TEXT, &value,-1);
		
		GtkListStore   *store;
  	GdkPixbuf       *icon;
 		
		store= GTK_LIST_STORE(model2);
			
	  icon = get_icon(PIXMAP_DIRECTORY "/Database.png");
    
		gtk_list_store_append(store, &new);

    gtk_list_store_set(store, &new,
                       COL_ICON, icon,
                       COL_TEXT, value,
                       -1);
		gtk_list_store_remove(GTK_LIST_STORE(model1), &iter);
	}
	
	gtk_tree_selection_select_iter(gtk_tree_view_get_selection(view2), &new);
}

void
alias_edited_callback                                            (GtkCellRendererText *cell, gchar *path_string, gchar *new_text, gpointer user_data)
{
	GtkTreeIter iter;
	GtkTreeView * view1 = GTK_TREE_VIEW(glade_xml_get_widget(xml,"cdbp3_tw_aliases"));
	GtkTreeModel * model1 = gtk_tree_view_get_model(view1);
	gtk_tree_model_get_iter_from_string (model1, &iter,path_string);
	gtk_list_store_set(
      GTK_LIST_STORE(model1), &iter,
      COL_TEXT+1, new_text,
    -1);
	
}
